/********************************************************************

					IPA nI\tgEFA琬
					u菑C^tF[X̍xv


		vO	FIC菑p^p@\
		@\			FIC菑p^𗘗p
		t@C		Fcpdb.c
		t@CTv	FCu\[Xt@C
		OS				FWindows95 {
		}V			FLnr̓삷}V
		RpC		FBorland C++ Ver 5.01J
		쐬			FHRF
		Zpw		F쐳
		쐬			F1997/10
					F

********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <jctype.h>
#include <dos.h>
#include "cpdb.h"
#include "handle.h"

enum{ HT_CPDB = 10, HT_CP };

enum{ PageCacheSize = 3 };

typedef struct{
	int left;
	int top;
	int right;
	int bottom;
} RECT;

typedef struct{
	OPDB_XY start;
	OPDB_XY step;
	OPDB_XY count;
	OPDB_XY size;
} FRAME;

typedef struct{
	HANDLE_LIST handle_list;
	HOPDB hopdb;
	HAIFMT set_aif;
	void *setai;
	WORD *text;
	int text_len;
	FRAME frame;
	HPAGEPAT *page_cach;
	int cach_size;
	int tag_no_offset;
	OPDB_XY input_reso, display_reso;
} CPDB_INFO;

typedef struct tagSTROKE_LIST{
	struct tagSTROKE_LIST *next;
	OPDB_XY *pt;
	int count;
} STROKE_LIST;

typedef struct{
	STROKE_LIST *head;
	STROKE_LIST **tail;
} MOJI_PATTERN;

typedef struct{
	HANDLE_LIST handle_list;
	MOJI_PATTERN mp;
} CP_INFO;

static int _init_flag = 0;
static HPAGEPAT _page_cach[PageCacheSize];
static OPDB_XY _margin_rate = { 100, 100 };

// =========================================================================
static int ismatch(
		char *fn, char *item, int type, int count, const void *data){
	int n, ret = 0;
	HOPDB hopdb;
	HAIFMT haif;
	if((hopdb = LoadOPDB(fn)) == NULL)
		return 0;
	haif = GetOPDBAddInfoFormat(hopdb, AIF_Set);
	n = GetAddInfoItemNo(haif, item);
	if(GetAddInfoItemType(haif, n) == type){
		char *info;
		if((info = malloc(GetAddInfoItemSize(haif, n) + 1)) == NULL)
			goto err1;
		LoadOPDBAddInfo(hopdb, GetAddInfoItemOffset(haif, n),
				info, GetAddInfoItemSize(haif, n));
		info[GetAddInfoItemSize(haif, n)] = 0;
		if(type == IT_Char)
			ret = !strcmp(info, (char *)data);
		else if(count == GetAddInfoItemArrayCount(haif, n))
			ret = !memcmp(info, data, GetAddInfoItemSize(haif, n));
		free(info);
	}
err1:
	ReleaseAddInfoFormat(haif);
	ReleaseOPDB(hopdb);
	return ret;
}

static void cfree(void *p){
	if(p != NULL)
		free(p);
}

#define ChgHL(W)			(((WORD)(W) >> 8) & 0xff | ((WORD)(W) << 8))
#define StoC(S)				ChgHL(*(WORD *)(S))

static long gettextsize(const char fn[]){
	int ch;
	long size = 0;
	unsigned moji;
	WORD spcl = StoC("@");
	FILE *fp;
	if((fp = fopen(fn, "rt")) == NULL)
		return 0;
	while((ch = fgetc(fp)) != EOF){
		moji = iskanji(ch) ? ((ch << 8) | fgetc(fp)): ch;
		if(moji == spcl || moji <= ' ')
			continue;
		size++;
	}
	fclose(fp);
	return size;
}

static WORD *loadtext(const char *fname){
	int ch, err;
	struct ffblk fb;
	FILE *fp;
	WORD moji, *text, *cur;
	WORD spcl = StoC("@");
	long size;
	if(findfirst(fname, &fb, FA_ARCH | FA_RDONLY))
		return NULL;
	size = gettextsize(fname);
	if((cur = text = malloc(sizeof(WORD) * (size + 1))) == NULL)
		return NULL;
	err = (fp = fopen(fname, "rt")) == NULL;
	while(!err && (ch = fgetc(fp)) != EOF){
		if(iskanji(moji = (unsigned)ch)){
			err = (ch = fgetc(fp)) == EOF;
			moji = (moji << 8) | ch;
		}
		if(moji > ' ' && moji != spcl)
			*cur++ = moji;
	}
	*cur = 0;
	if(fp != NULL) fclose(fp);
	if(err){
		if(text != NULL) free(text);
		text = NULL;
	}
	return text;
}

static int textlen(WORD *text){
	int i;
	for(i = 0; *text++ != 0; i++);
	return i;
}

static int getnearframeno(FRAME *frame, OPDB_XY *pt){
	int m, n, limit;
	n = 0;
	limit = frame->start.y + (frame->size.y - frame->step.y) / 2;
	if(pt->y >= limit){
		n = (pt->y - limit) / frame->step.y;
		if(n >= frame->count.y)
			n = frame->count.y - 1;
	}
	m = 0;
	limit = frame->start.x + (frame->size.x - frame->step.x) / 2;
	if(pt->x >= limit){
		m = (pt->x - limit) / frame->step.x;
		if(m >= frame->count.x)
			m = frame->count.x - 1;
	}
	if(abs(frame->step.x * m + (frame->size.x >> 1) +
			frame->start.x - pt->x) >
			(long)_margin_rate.x * frame->size.x / 200 ||
			abs(frame->step.y * n + (frame->size.y >> 1) +
			frame->start.y - pt->y) >
			(long)_margin_rate.y * frame->size.y / 200)
		return -1;
	return n * frame->count.x + m;
}

static void getframeorgpos(FRAME *frame, int n, OPDB_XY *org){
	org->x = (n % frame->count.x) * frame->step.x + frame->start.x;
	org->y = (n / frame->count.x) * frame->step.y + frame->start.y;
}

static void getstrokerect(RECT *rc, OPDB_XY *pt, int count){
	int i;
	rc->left = rc->right = pt->x;
	rc->top = rc->bottom = pt->y;
	for(i = 1, pt++; i < count; i++, pt++){
		if(rc->left > pt->x)
			rc->left = pt->x;
		else if(rc->right < pt->x)
			rc->right = pt->x;
		if(rc->top > pt->y)
			rc->top = pt->y;
		else if(rc->bottom < pt->y)
			rc->bottom = pt->y;
	}
}

static int addmpstroke(MOJI_PATTERN *mp, OPDB_XY *pbuf, int count){
	STROKE_LIST *st;
	if((st = malloc(sizeof(*st))) == NULL)
		return 1;
	st->pt = pbuf;
	st->count = count;
	st->next = NULL;
	*(mp->tail) = st;
	mp->tail = &(st->next);
	return 0;
}

static void convscale(OPDB_XY *src, OPDB_XY *dst, OPDB_XY *pt){
	pt->x = (int)((long)pt->x * dst->x * 2 / src->x + 1 >> 1);
	pt->y = (int)((long)pt->y * dst->y * 2 / src->y + 1 >> 1);
}

static void freestlist(STROKE_LIST *st){
	STROKE_LIST *next;
	while(st != NULL){
		next = st->next;
		free(st->pt);
		free(st);
		st = next;
	}
}

static void initmp(MOJI_PATTERN *mp){
	mp->head = NULL;
	mp->tail = &(mp->head);
}

static void freemp(MOJI_PATTERN *mp){
	freestlist(mp->head);
	initmp(mp);
}

static void moveorg(OPDB_XY *pt, int count, OPDB_XY *org){
	int i;
	for(i = 0; i < count; i++, pt++){
		pt->x -= org->x;
		pt->y -= org->y;
	}
}

static void movemporg(MOJI_PATTERN *mp, OPDB_XY *org){
	STROKE_LIST *sl;
	sl = mp->head;
	while(sl != NULL){
		moveorg(sl->pt, sl->count, org);
		sl = sl->next;
	}
}

static int hpptomp(HPAGEPAT hpp,
		FRAME *frame, int tag_no_offset, int frame_no, MOJI_PATTERN *mp){
	int i, count, pc;
	SHORT tag_no;
	OPDB_XY *pt;
	RECT rc;
	OPDB_XY center;
	int err = 1;
	initmp(mp);
	count = GetOPDBStrokeCount(hpp);
	for(i = 0; i < count; i++){
		if(tag_no_offset >= 0){
			GetOPDBStrokeAddInfo(hpp, i,
					tag_no_offset, &tag_no, sizeof(tag_no));
			if(tag_no != frame_no)
				continue;
		}
		pc = GetOPDBPointCount(hpp, i);
		if((pt = malloc(sizeof(*pt) * pc)) == NULL)
			goto err1;
		GetOPDBStrokeXY(hpp, i, pt, NULL, pc);
		if(tag_no_offset < 0){
			getstrokerect(&rc, pt, pc);
			center.x = rc.left + rc.right >> 1;
			center.y = rc.top + rc.bottom >> 1;
			tag_no = getnearframeno(frame, &center);
			if(tag_no != frame_no){
				free(pt);
				continue;
			}
		}
		if(addmpstroke(mp, pt, pc)){
			free(pt);
			goto err1;
		}
	}
	{
		OPDB_XY org;
		getframeorgpos(frame, frame_no, &org);
		movemporg(mp, &org);
	}
	err = 0;
err1:
	if(err){
		freemp(mp);
	}
	return err;
}

static int opdbtomp(CPDB_INFO *ci, int moji_no, MOJI_PATTERN *mp){
	int i, cach_no;
	int page_no, frame_no;
	HPAGEPAT hpp;
	HPAGEPAT *page_cach = ci->page_cach;
	page_no = moji_no / (ci->frame.count.x * ci->frame.count.y);
	if(page_no >= GetOPDBPageCount(ci->hopdb)){
		initmp(mp);
		return 0;
	}
	frame_no = moji_no % (ci->frame.count.x * ci->frame.count.y);
	cach_no = -1;
	for(i = 0; i < ci->cach_size; i++){
		if(page_cach[i] == NULL)
			break;
		if(GetPagePatternOPDB(page_cach[i]) == ci->hopdb &&
				GetOPDBPageNo(page_cach[i]) == page_no){
			cach_no = i;
			break;
		}
	}
	if(cach_no < 0){
		if((hpp = LoadOPDBPagePattern(ci->hopdb, page_no)) == NULL)
			return 1;
		cach_no = ci->cach_size - 1;
		if(page_cach[cach_no] != NULL)
			ReleaseOPDBPagePattern(page_cach[cach_no]);
	}else
		hpp = page_cach[cach_no];
	for(i = cach_no; i > 0; i--)
		page_cach[i] = page_cach[i - 1];
	page_cach[0] = hpp;
	return hpptomp(hpp, &ci->frame, ci->tag_no_offset, frame_no, mp);
}

static int getaddinfoitemdata(HAIFMT haif,
		const void *data, const char *item, void *buf, int type, int count){
	int n;
	void *src_buf;
	int src_type, src_count, src_offset;
	if((n = GetAddInfoItemNo(haif, item)) == NULL)
		return 1;
	src_type = GetAddInfoItemType(haif, n);
	src_count = GetAddInfoItemArrayCount(haif, n);
	src_offset = GetAddInfoItemOffset(haif, n);
	TransferAddInfo(data,
			src_offset, src_type, src_count, buf, 0, type, count);
	return 0;
}

static WORD *loadtextex(const char *fname, const char *fn, const char *dir){
	WORD *text = NULL;
	char path[MAXPATH];
	int i, p = 0, pp;
	char *dirp;
	if(dir == NULL)
		dir = "";
	if((dirp = malloc(
			sizeof(*dirp) * (strlen(dir) + 1 + MAXDIR + 2))) == NULL)
		return NULL;
	strcpy(dirp, dir);
	strcat(dirp, ";.;");
	{
		char dr[MAXDRIVE], di[MAXDIR];
		fnsplit(fn, dr, di, NULL, NULL);
		fnmerge(&dirp[strlen(dirp)], dr, di, NULL, NULL);
	}
	for(;;){
		pp = p;
		for(; dirp[p] != ';' && dirp[p]; p++);
		{
			char di[MAXDIR];
			for(i = pp; i < p; i++)
				di[i - pp] = dirp[i];
			di[i - pp] = 0;
			fnmerge(path, NULL, di, fname, NULL);
		}
		if((text = loadtext(path)) != NULL)
			break;
		if(!dirp[p])
			break;
		p++;
	}
	return text;
}

// =========================================================================
HCPDB LoadCPDB(const char *fn, const char *text_dir){
	int sz, err = 1;
	CPDB_INFO *ci;
	if((ci = makehandleinfo(HT_CPDB, sizeof(*ci))) == NULL)
		return NULL;
	ci->cach_size = 0;
	if((ci->hopdb = LoadOPDB(fn)) == NULL)
		goto err1;
	if((ci->set_aif = GetOPDBAddInfoFormat(ci->hopdb, AIF_Set)) == NULL)
		goto err1;
	if((sz = GetAddInfoSize(ci->set_aif)) <= 0)
		goto err1;
	if((ci->setai = malloc(sz)) == NULL)
		goto err1;
	if(LoadOPDBAddInfo(ci->hopdb, 0, ci->setai, sz))
		goto err1;
	{
		char tfn[MAXFILE + MAXEXT];
		getaddinfoitemdata(ci->set_aif,
				ci->setai, "input text", tfn, IT_Char, sizeof(tfn) - 1);
		tfn[sizeof(tfn) - 1] = 0;
		if((ci->text = loadtextex(tfn, fn, text_dir)) == NULL)
			goto err1;
	}
	ci->text_len = textlen(ci->text);
	ci->cach_size = sizeof(_page_cach) / sizeof(*_page_cach);
	ci->page_cach = _page_cach;
	if(!_init_flag){
		int i;
		for(i = 0; i < ci->cach_size; i++)
			ci->page_cach[i] = NULL;
		_init_flag = !0;
	}
	{
		HAIFMT haif;
		int n;
		SHORT tmp;
		if((haif = GetOPDBAddInfoFormat(ci->hopdb, AIF_Stroke)) == NULL)
			goto err1;
		ci->tag_no_offset = -1;
/*		if(!getaddinfoitemdata(
				ci->set_aif, ci->setai, "tag No", &tmp, IT_Word, 1))
			ci->tag_no_offset = tmp;*/
		ReleaseAddInfoFormat(haif);
	}
	{
		int f1, f2;
		f1 = getaddinfoitemdata(ci->set_aif, ci->setai,
				"input resolution", &ci->input_reso, IT_Word, 2);
		f2 = getaddinfoitemdata(ci->set_aif, ci->setai,
				"display resolution", &ci->display_reso, IT_Word, 2);
		if(!f1 && f2)
			ci->display_reso = ci->input_reso;
		else if(f1 && !f2)
			ci->input_reso = ci->display_reso;
		else if(f1 && f2){
			ci->input_reso.x = ci->display_reso.x = 640;
			ci->input_reso.y = ci->display_reso.y = 480;
		}
	}
	{
		err = 0;
		err |= getaddinfoitemdata(ci->set_aif,
				ci->setai, "frame count", &ci->frame.count, IT_Word, 2);
		err |= getaddinfoitemdata(ci->set_aif,
				ci->setai, "frame start", &ci->frame.start, IT_Word, 2);
		err |= getaddinfoitemdata(ci->set_aif,
				ci->setai, "frame step", &ci->frame.step, IT_Word, 2);
		err |= getaddinfoitemdata(ci->set_aif,
				ci->setai, "frame size", &ci->frame.size, IT_Word, 2);
		convscale(&ci->display_reso, &ci->input_reso, &ci->frame.start);
		convscale(&ci->display_reso, &ci->input_reso, &ci->frame.step);
		convscale(&ci->display_reso, &ci->input_reso, &ci->frame.size);
	}
err1:
	if(err){
		ReleaseCPDB(ci->handle_list.handle);
		return NULL;
	}
	return ci->handle_list.handle;
}

void ReleaseCPDB(HCPDB hcpdb){
	CPDB_INFO *ci;
	if((ci = handletopt(hcpdb, HT_CPDB)) == NULL)
		return;
	ReleaseAddInfoFormat(ci->set_aif);
	cfree(ci->setai);
	cfree(ci->text);
	{
		int i, j;
		for(i = 0; i < ci->cach_size; i++){
			if(GetPagePatternOPDB(ci->page_cach[i]) == ci->hopdb){
				ReleaseOPDBPagePattern(ci->page_cach[i]);
				for(j = i + 1; j < ci->cach_size; j++)
					ci->page_cach[j - 1] = ci->page_cach[j];
				ci->page_cach[ci->cach_size - 1] = NULL;
				i--;
			}
		}
	}
	ReleaseOPDB(ci->hopdb);
	removehandleinfo(hcpdb, HT_CPDB);
}

HOPDB GetCPDBsOPDB(HCPDB hcpdb){
	CPDB_INFO *ci;
	if((ci = handletopt(hcpdb, HT_CPDB)) == NULL)
		return NULL;
	return ci->hopdb;
}

unsigned GetCPDBCharCode(HCPDB hcpdb, int char_no){
	CPDB_INFO *ci;
	if((ci = handletopt(hcpdb, HT_CPDB)) == NULL)
		return 0;
	if(char_no < 0 || char_no >= ci->text_len)
		return 0;
	return ci->text[char_no];
}

int GetCPDBCharNo(HCPDB hcpdb, unsigned code, int start_no){
	int i;
	CPDB_INFO *ci;
	WORD *ch;
	if((ci = handletopt(hcpdb, HT_CPDB)) == NULL)
		return -1;
	if(start_no < 0)
		start_no = 0;
	else if(start_no >= ci->text_len)
		return -1;
	for(ch = &ci->text[i = start_no]; i < ci->text_len; i++, ch++){
		if(*ch == code)
			return i;
	}
	return -1;
}

int GetCPDBCharCount(HCPDB hcpdb){
	CPDB_INFO *ci;
	if((ci = handletopt(hcpdb, HT_CPDB)) == NULL)
		return 0;
	return ci->text_len;
}

HCHARPAT LoadCPDBCharPattern(HCPDB hcpdb, int char_no){
	int err = 1;
	CPDB_INFO *ci;
	CP_INFO *cp;
	if((ci = handletopt(hcpdb, HT_CPDB)) == NULL)
		return NULL;
	if(char_no < 0 || char_no >= ci->text_len)
		return NULL;
	if((cp = makehandleinfo(HT_CP, sizeof(*cp))) == NULL)
		return NULL;
	if(opdbtomp(ci, char_no, &cp->mp))
		goto err1;
	err = 0;
err1:
	if(err){
		ReleaseCPDBCharPattern(cp->handle_list.handle);
		return NULL;
	}
	return cp->handle_list.handle;
}

void ReleaseCPDBCharPattern(HCHARPAT hcp){
	CP_INFO *cp;
	if((cp = handletopt(hcp, HT_CP)) == NULL)
		return;
	freemp(&cp->mp);
	removehandleinfo(hcp, HT_CP);
}

OPDB_XY *GetCPStroke(HCHARPAT hcp, int stroke_no){
	int n = 0;
	STROKE_LIST *sl;
	CP_INFO *cp;
	if((cp = handletopt(hcp, HT_CP)) == NULL)
		return NULL;
	sl = cp->mp.head;
	while(sl != NULL){
		if(n++ == stroke_no)
			return sl->pt;
		sl = sl->next;
	}
	return NULL;
}

int GetCPStrokeCount(HCHARPAT hcp){
	int n = 0;
	STROKE_LIST *sl;
	CP_INFO *cp;
	if((cp = handletopt(hcp, HT_CP)) == NULL)
		return 0;
	sl = cp->mp.head;
	while(sl != NULL){
		n++;
		sl = sl->next;
	}
	return n;
}

int GetCPPointCount(HCHARPAT hcp, int stroke_no){
	int n = 0;
	STROKE_LIST *sl;
	CP_INFO *cp;
	if((cp = handletopt(hcp, HT_CP)) == NULL)
		return 0;
	sl = cp->mp.head;
	while(sl != NULL){
		if(n++ == stroke_no)
			return sl->count;
		sl = sl->next;
	}
	return 0;
}

int GetCPDBAddInfo(HCPDB hcpdb,
		const char *item_name, void *buf, int type, int count){
	CPDB_INFO *ci;
	if((ci = handletopt(hcpdb, HT_CPDB)) == NULL)
		return 1;
	return getaddinfoitemdata(
			ci->set_aif, ci->setai, item_name, buf, type, count);
}

void SetCPDBFrameMargin(int rx, int ry){
	_margin_rate.x = rx;
	_margin_rate.y = ry;
}

void GetCPDBFrameMargin(OPDB_XY *rate){
	*rate = _margin_rate;
}

int findCPDB(ENUMCPDB *encp,
		const char *wildcard, const char *key, char *buf, int bufsize){
	int ret;
	char fn[MAXPATH];
	if(bufsize > 0)
		buf[0] = 0;
	if(wildcard != NULL){
		ret = findfirst(wildcard, &encp->fb, FA_ARCH | FA_RDONLY);
		fnsplit(wildcard, encp->drive, encp->dir, NULL, NULL);
	}else{
		ret = findnext(&encp->fb);
	}
	if(ret)
		return 0;
	for(;;){
		fnmerge(fn, encp->drive, encp->dir, encp->fb.ff_name, NULL);
		if(ismatch(fn, "input text", IT_Char, 0, key))
			break;
		if(findnext(&encp->fb))
			return 0;
	}
	strncpy(buf, fn, bufsize - 1);
	buf[bufsize - 1] = 0;
	return 1;
}

/*
====================================================
	ALL Rights Reserved. Copyright(C) 1997,1998
	Information-Technology Promotion Agency &
	Hitachi Software Engineering Co.,Ltd.
====================================================
*/
