/*
-----------------------------------------------------------------------------

					IPDB handle management library

											95/ 5/ 3	programmed by K.A

-----------------------------------------------------------------------------
*/

#include <stdlib.h>
#include "handle.h"

#include "bctovc.h"

#define HandleTableSizeDigit				8
#define HandleTableSize						(1 << HandleTableSizeDigit)

static HANDLE_LIST *handle_table[HandleTableSize];
static unsigned _init_flag = 0, _handle_count = 0, _cur_handle_no = 0;

static void inithandletable(void){
	int i;
	for(i = 0; i < HandleTableSize; i++)
		handle_table[i] = NULL;
}

static void **gethandleinfopt(unsigned handle){
	HANDLE_LIST *tmp, **prev;
	if(!_init_flag || handle == NULL)
		return NULL;
	prev = &handle_table[handle & (HandleTableSize - 1)];
	while((tmp = *prev) != NULL){
		if(tmp->handle == handle)
			break;
		prev = &(tmp->next);
	}
	if(tmp == NULL)
		return NULL;
	return (void **)prev;
}

static void **handletodatapt(unsigned handle, int type){
	HANDLE_LIST **hl;
	if(((void **)hl = gethandleinfopt(handle)) == NULL || (*hl)->type != type)
		return NULL;
	return (void **)hl;
}

void *handletopt(unsigned handle, int type){
	HANDLE_LIST *tmp;
	if(!_init_flag)
		return NULL;
	tmp = handle_table[handle & (HandleTableSize - 1)];
	while(tmp != NULL){
		if(tmp->handle == handle)
			if(tmp->type == type)
				break;
			else
				return NULL;
		tmp = tmp->next;
	}
	return tmp;
}

void *makehandleinfo(int type, int size){
	HANDLE_LIST *hl;
	if(_handle_count == MaxHandleCount)
		return NULL;
	if(!_init_flag){
		inithandletable();
		_init_flag = 1;
	}
	if((hl = calloc(max(sizeof(HANDLE_LIST), size), 1)) == NULL)
		return NULL;
	_handle_count++;
	do{
		if(_cur_handle_no == NULL)
			_cur_handle_no++;
	}while(gethandleinfopt(_cur_handle_no++) != NULL);
	hl->next = handle_table[
			(hl->handle = _cur_handle_no - 1) & (HandleTableSize - 1)];
	handle_table[hl->handle & (HandleTableSize - 1)] = hl;
	hl->type = type;
	return hl;
}

int removehandleinfo(unsigned handle, int type){
	HANDLE_LIST **hl, *tmp;
	if(((void **)hl = handletodatapt(handle, type)) == NULL)
		return 1;
	tmp = (*hl)->next;
	free(*hl);
	*hl = tmp;
	_cur_handle_no = handle;
	_handle_count--;
	return 0;
}

unsigned gethandlecount(void){
	return _handle_count;
}
