/*
-----------------------------------------------------------------------------

						IPDB Library header file

												Copyrighted by K.A

-----------------------------------------------------------------------------
*/

#ifndef __IPDBSYS_H__

#define __IPDBSYS_H__

#define IPDB_MaxIndexNameLen			81

enum{
	IPDB_FileOpenError = 1, IPDB_MemoryAllocError,
	IPDB_IllegalHeader, IPDB_WriteError, IPDB_ReadError, IPDB_IllegalHandle,
	IPDB_IllegalValue, IPDB_SeekError, IPDB_IllegalFile, IPDB_HandleOver,
	IPDB_IllegalName, IPDB_AlreadyExist, IPDB_NoMatchMemory
};

typedef unsigned HIPDB;

#ifdef __cplusplus
extern "C" {
#endif

/* IPDB t@C쐬 */
HIPDB CreateIPDB(const char file_name[]);
/* IPDB t@Cǂݍ */
HIPDB LoadIPDB(const char file_name[]);
/* IPDB t@C */
int ReleaseIPDB(HIPDB hipdb);
/* IPDB ̃t@C𓾂 */
int GetIPDBFileName(HIPDB hipdb, char fn_buf[], int buf_size);

/* CfNXCfNXԍ𓾂 */
int GetIPDBIndexNo(HIPDB hipdb, const char index_name[]);
/* CfNXԍCfNX𓾂 */
int GetIPDBIndexName(HIPDB hipdb, int index_No, char name_buf[], int buf_size);
/* CfNX̐𓾂 */
int GetIPDBIndexCount(HIPDB hipdb);
/* CfNX */
int MakeIPDBIndex(HIPDB hipdb, const char index_name[], unsigned page_count);
/* CfNX폜 */
int RemoveIPDBIndex(HIPDB hipdb, const char index_name[]);
/* y[W𓾂 */
unsigned GetIPDBIndexPageCount(HIPDB hipdb, int index_No);

/* y[Wǉ */
int AddIPDBIndexPages(HIPDB hipdb,
		int index_No, unsigned page_pos, unsigned page_count);
/* y[W폜 */
int DeleteIPDBIndexPages(HIPDB hipdb,
		int index_No, unsigned page_pos, unsigned page_count);

/* ݃I[vĂy[W̃CfNXԍ𓾂 */
int GetIPDBPageIndexNo(HIPDB hipdb);
/* ݃I[vĂy[Wԍ𓾂 */
unsigned GetIPDBPageNo(HIPDB hipdb);
/* y[WI[vĂ邩ǂׂ */
int IsIPDBPageOpened(HIPDB hipdb);
/* ݃I[vĂy[W̃TCY𓾂 */
long GetIPDBPageSize(HIPDB hipdb);
/* y[WCgI[v */
int WriteOpenIPDBPage(
		HIPDB hipdb, int index_No, unsigned page_No, long size);
/* y[W[hI[v */
int ReadOpenIPDBPage(HIPDB hipdb, int index_No, unsigned page_No);
/* y[W[hCgI[v */
int UpdateOpenIPDBPage(HIPDB hipdb, int index_No, unsigned page_No);
/* y[WN[Y */
int CloseIPDBPage(HIPDB hipdb);
/* y[WV[N */
int SeekIPDBPage(HIPDB hipdb, long offset);
/* y[Wł݂̌̈ʒu𓾂 */
long GetIPDBPageOffset(HIPDB hipdb);
/* y[WɃf[^ */
int WriteIPDBPage(HIPDB hipdb, void *data, long size);
/* y[Wf[^ǂݍ */
int ReadIPDBPage(HIPDB hipdb, void *data, long size);

/* wfBNgŃj[NȐl̃t@C */
int MakeNewFileName(const char *dir, const char *ext, long base, char *fname);
/* IPDB ̖gp̈̃TCY𓾂 */
long GetIPDBFlagSize(HIPDB hipdb);
/* IPDB ̖gp̈폜 */
int ArrangeIPDB(HIPDB hipdb);

/* G[R[h𓾂 */
int GetIPDBError(void);

#ifdef	__cplusplus
}
#endif

#endif
