/*
------------------------------------------------------------------------------

					f[^x[XWc[ Version 4.50

													v[WfRpC

------------------------------------------------------------------------------
*/

#include "wintool.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <alloc.h>
#include <math.h>
#include <dos.h>
#include <dir.h>
#include <jctype.h>
#include <penwin.h>
#include "mdbio2.h"
#include "ipdbsys.h"
#include "opdb.h"
#include "rlb.h"

#define IsKanji(C)		((UINT)(C) >= 0x80) 
#define ColorCount		8
#define FontCount		2

#define CfgStrSize		80
#define RLBSizeX		640
#define RLBSizeY		480

enum{
	ClearSwitchHeight = 10
};

enum{
	WC_New = 1, WC_Continue = 2, WC_Stop = 3,
	WC_Exit = 101, WC_Clear = 103, WC_About = 104, WC_Prev = 105,
	WC_Next = 106, WC_NextModify = 107, WC_PrevModify = 108
};

enum{
	WriteMoji, SelectName, PutTitle
};

typedef struct{
	SHORT year, month, day;
} HIZUKE;

typedef struct{
	char hour, minute, second;
} JIKOKU;

typedef struct{
	/* administrator info */
	char ad_assign[41], ad_name[31], ad_mail[31];
	/* writer's data */
	char writer[31], language[15];
	char hand, nhand;
	char motive[15], comment[201];
	HIZUKE b_day;
	/* first time */
	HIZUKE f_day;
	JIKOKU f_time;
	/* last time */
	HIZUKE l_day;
	JIKOKU l_time;
	/* input text */
	char text_file[MAXFILE + MAXEXT - 1];
	/* frame data */
	FRAME frame;
	/* tablet data */
	char tab_maker[21];
	char tab_name[21];
	OPDB_XY input_reso, display_reso, tab_size;
	SHORT sam_rate;
	/* current page */
	SHORT cur_page;
	char over_point;
	char tmp_name[MAXFILE + MAXEXT - 1];
} SET_AI;

typedef struct tagFILE_LIST{
	char fname[MAXFILE + MAXEXT - 1];
	char explain[81];
	struct tagFILE_LIST *next;
} FILE_LIST;

typedef struct{
	SET_AI ai;
	OPDB_XY clsw_pos, clsw_size;
	OPDB_XY letter_pos, letter_size;
	OPDB_XY input_reso, display_reso, tab_size;
	int cflag, over_point, srate, frame_count, rlbdiv;
	long basenum, deflaglimit;
	FILE_LIST *text_list;
	char dbdir[MAXDRIVE + MAXDIR - 1];
	char template[MAXFILE + MAXEXT - 1];
	char dbext[MAXEXT];
	char readme[MAXFILE + MAXEXT - 1];
	char font[31];
	CHECK_LIST **chklist;
	int n_margin;
} SETTEI;

typedef struct{
	HPEN hpen[ColorCount];
	HBRUSH hbrush[ColorCount];
	HFONT hfont[FontCount];
} DRAWTOOL;

typedef struct{
	SETTEI set;
	DRAWTOOL gobj;
	int page_No;
	int page_count, moji_count, rlb_count;
	int update, renew, mode;
	WORD *text;
	struct{
		char fname[MAXFILE + MAXEXT - 1];
	} *rlblist;
	HBITMAP name_bmp, tmp_bmp;
	HOPDB hopdb;
	MOJI_PATTERN *mp;
	HWND hmsgbox;
	HCURSOR refer_csr, erase_csr;
} APPDATA;

enum{
	BLACK, BLUE, RED, MAGENTA, GREEN, CYAN, GRAY, WHITE, DOT_LINE = 8
};

typedef struct{
	int r, g, b;
} RGBCOL;

const RGBCOL _rgbtbl[] = {
	{ 0, 0, 0},
	{ 0, 0, 255},
	{ 255, 0, 0},
	{ 255, 0, 255},
	{ 0, 255, 0},
	{ 240, 240, 240},
	{ 192, 192, 192},
	{ 255, 255, 255}
};

const char _titletext[] = "f[^x[XWc[ '96 t";
const char _chk_ext[] = ".mcl";
const char _msg_box_class[] = "msgbox";
const char _class_name[] = "mdbc96";

HINSTANCE hpenwin = NULL;
HPENDATA (WINAPI *lpCreatePenData)(LPPENINFO, int, UINT, UINT);
BOOL (WINAPI *lpGetPenDataInfo)(HPENDATA, LPPENDATAHEADER, LPPENINFO, DWORD);
REC (WINAPI *lpGetPenHwEventData)(
		UINT, UINT, LPPOINT, LPVOID, int, LPSTROKEINFO);
BOOL (WINAPI *lpIsPenEvent)(UINT, LONG);
BOOL (WINAPI *lpTPtoDP)(LPPOINT, int);
BOOL (WINAPI *lpDPtoTP)(LPPOINT, int);

#ifdef __WIN32__
#define MoveTo(H, X, Y)						MoveToEx(H, X, Y, NULL)

DWORD GetTextExtent(HDC hdc, LPCSTR str, int len){
	SIZE sz;
	GetTextExtentPoint32(hdc, str, len, &sz);
	return (sz.cy & 0xffff) << 16 | (sz.cx & 0xffff);
}

#endif

enum{ AI_AddItem = 1, AI_ToVar, AI_ToBuf };

int setaiitem(int cmd, HAIFMT haif, void *buf,
		LPCSTR name, int type, int count, void *var){
	int err = 0, n;
	switch(cmd){
	case AI_AddItem:
		err = AddAddInfoItem(haif, name, type, count);
		break;
	case AI_ToVar:
		n = GetAddInfoItemNo(haif, name);
		TransferAddInfo(buf, GetAddInfoItemOffset(haif, n),
				GetAddInfoItemType(haif, n), GetAddInfoItemArrayCount(haif, n),
				var, 0, type, count);
		break;
	case AI_ToBuf:
		n = GetAddInfoItemNo(haif, name);
		TransferAddInfo(var, 0, type, count,
				buf, GetAddInfoItemOffset(haif, n),
				GetAddInfoItemType(haif, n),
				GetAddInfoItemArrayCount(haif, n));
		break;
	}
	return err;
}

int setaipt(int cmd, HAIFMT haif, void *buf, LPCSTR name, OPDB_XY *pt){
	int err;
	SHORT tmp[2];
	tmp[0] = pt->x;
	tmp[1] = pt->y;
	err = setaiitem(cmd, haif, buf, name, IT_Word, 2, tmp);
	pt->x = tmp[0];
	pt->y = tmp[1];
	return err;
}

HAIFMT MakeSetAI(int cmd, HAIFMT haif, void *buf, SET_AI *ai){
	int err = 0;
	SET_AI *dmy;
	if(cmd == AI_AddItem)
		if((haif = CreateAddInfoFormat()) == NULL)
			return NULL;
	err = setaiitem(cmd, haif, buf,
			"ad. affiliation", IT_Char, sizeof(ai->ad_assign), ai->ad_assign);
	err = setaiitem(cmd, haif, buf,
			"administrator", IT_Char, sizeof(ai->ad_name), ai->ad_name);
	err = setaiitem(cmd, haif, buf,
			"ad. mail", IT_Char, sizeof(ai->ad_mail), ai->ad_mail);
	err = setaiitem(cmd, haif, buf,
			"writer", IT_Char, sizeof(ai->writer), ai->writer);
	err |= setaiitem(cmd, haif, buf,
			"native language", IT_Char, sizeof(ai->language), ai->language);
	err |= setaiitem(cmd, haif, buf, "writing hand", IT_Char, 1, &ai->hand);
	err |= setaiitem(cmd, haif, buf, "dominant hand", IT_Char, 1, &ai->nhand);
	err |= setaiitem(cmd, haif, buf,
			"motivation", IT_Char, sizeof(ai->motive), ai->motive);
	err |= setaiitem(cmd, haif, buf, "birth day", IT_Word, 3, &ai->b_day);
	err |= setaiitem(cmd, haif, buf,
			"comment", IT_Char, sizeof(ai->comment), ai->comment);
	err |= setaiitem(cmd, haif, buf, "first date", IT_Word, 3, &ai->f_day);
	err |= setaiitem(cmd, haif, buf, "first time", IT_Byte, 3, &ai->f_time);
	err |= setaiitem(cmd, haif, buf, "last date", IT_Word, 3, &ai->l_day);
	err |= setaiitem(cmd, haif, buf, "last time", IT_Byte, 3, &ai->l_time);
	err |= setaiitem(cmd, haif, buf,
			"input text", IT_Char, sizeof(ai->text_file), ai->text_file);
	err |= setaipt(cmd, haif, buf, "frame start", &ai->frame.start);
	err |= setaipt(cmd, haif, buf, "frame step", &ai->frame.step);
	err |= setaipt(cmd, haif, buf, "frame count", &ai->frame.count);
	err |= setaipt(cmd, haif, buf, "frame size", &ai->frame.size);
	err |= setaiitem(cmd, haif, buf,
			"tablet maker", IT_Char, sizeof(ai->tab_maker), ai->tab_maker);
	err |= setaiitem(cmd, haif, buf,
			"tablet name", IT_Char, sizeof(ai->tab_name), ai->tab_name);
	err |= setaipt(cmd, haif, buf, "input resolution", &ai->input_reso);
	err |= setaipt(cmd, haif, buf, "display resolution", &ai->display_reso);
	err |= setaipt(cmd, haif, buf, "tablet size", &ai->tab_size);
	err |= setaiitem(
			cmd, haif, buf, "sampling rate", IT_Word, 1, &ai->sam_rate);
	err |= setaiitem(
			cmd, haif, buf, "current page", IT_Word, 1, &ai->cur_page);
	err |= setaiitem(cmd,
			haif, buf, "over point", IT_Byte, 1, &ai->over_point);
	err |= setaiitem(cmd, haif, buf, "template name",
			IT_Char, sizeof(ai->tmp_name), ai->tmp_name);
	if(cmd == AI_AddItem && err){
		ReleaseAddInfoFormat(haif);
		haif = NULL;
	}
	return haif;
}

void nomemproc(HWND hwnd){
	MessageBox(hwnd,
			"Memory allocate error !", "ERROR !", MB_ICONEXCLAMATION | MB_OK);
	PostMessage(hwnd, WM_COMMAND, WC_Exit, 0);
}

#define EraseSize			20

void drawbmp(HWND hwnd, HDC hdc, HBITMAP hbm, POINT *pt){
	int x, y;
	HDC hmemdc;
	POINT cp, old;
	HBITMAP oldbm;
	HPEN hpen, oldpen;
	hmemdc = CreateCompatibleDC(hdc);
	oldbm = SelectObject(hmemdc, hbm);
	hpen = GetStockObject(WHITE_PEN);
	oldpen = SelectObject(hmemdc, hpen);
	MoveTo(hdc, pt->x, pt->y);
	LineTo(hdc, pt->x + 1, pt->y);
	x = (int)((long)pt->x * RLBSizeX / GetSystemMetrics(SM_CXSCREEN));
	y = (int)((long)pt->y * RLBSizeY / GetSystemMetrics(SM_CYSCREEN));
	MoveTo(hmemdc, x, y);
	LineTo(hmemdc, x + 1, y);
	MoveTo(hdc, pt->x, pt->y);
	MoveTo(hmemdc, x, y);
	old = *pt;
	while(GetAsyncKeyState(VK_LBUTTON) & 0x8000){
		GetCursorPos(&cp);
		ScreenToClient(hwnd, &cp);
		if(old.x != cp.x || old.y != cp.y){
			LineTo(hdc, cp.x, cp.y);
			x = (int)((long)cp.x * RLBSizeX / GetSystemMetrics(SM_CXSCREEN));
			y = (int)((long)cp.y * RLBSizeY / GetSystemMetrics(SM_CYSCREEN));
			LineTo(hmemdc, x, y);
			old = cp;
		}
	}
	SelectObject(hmemdc, oldbm);
	SelectObject(hmemdc, oldpen);
	DeleteObject(hpen);
	DeleteDC(hmemdc);
}

void eraserect(HDC hdc, HDC hbkdc, HDC hmemdc, POINT *pt){
	int x, y, sizex, sizey;
	SetStretchBltMode(hdc, STRETCH_ANDSCANS);
	sizex = (int)((long)EraseSize * GetSystemMetrics(SM_CXSCREEN) / RLBSizeX);
	sizey = (int)((long)EraseSize * GetSystemMetrics(SM_CYSCREEN) / RLBSizeY);
	x = (int)((long)pt->x * RLBSizeX / GetSystemMetrics(SM_CXSCREEN));
	y = (int)((long)pt->y * RLBSizeY / GetSystemMetrics(SM_CYSCREEN));
	BitBlt(hdc, pt->x - sizex / 2, pt->y - sizey / 2, sizex, sizey,
			hbkdc, pt->x - sizex / 2, pt->y - sizey / 2, SRCCOPY);
	Rectangle(hmemdc, x - EraseSize / 2,
			y - EraseSize / 2, x + EraseSize / 2, y + EraseSize / 2);
}

void erasedraw(HWND hwnd, HDC hdc, HBITMAP hbm, HBITMAP hbk, POINT *fp){
	HDC hbkdc, hmemdc;
	POINT cp, old;
	HBITMAP oldbkbm, oldbm;
	HPEN hpen, oldpen;
	HBRUSH hbrush, oldbr;

	hpen = GetStockObject(BLACK_PEN);
	hbrush = GetStockObject(BLACK_BRUSH);
	hbkdc = CreateCompatibleDC(hdc);
	hmemdc = CreateCompatibleDC(hdc);
	oldbkbm = SelectObject(hbkdc, hbk);
	oldbm = SelectObject(hmemdc, hbm);
	oldpen = SelectObject(hmemdc, hpen);
	oldbr = SelectObject(hmemdc, hbrush);
	eraserect(hdc, hbkdc, hmemdc, fp);
	old = *fp;
	while(GetAsyncKeyState(VK_RBUTTON) & 0x8000){
		GetCursorPos(&cp);
		ScreenToClient(hwnd, &cp);
		if(old.x != cp.x || old.y != cp.y){
			eraserect(hdc, hbkdc, hmemdc, &cp);
			old = cp;
		}
	}
	SelectObject(hmemdc, oldbm);
	SelectObject(hbkdc, oldbkbm);
	SelectObject(hmemdc, oldpen);
	SelectObject(hmemdc, oldbr);
	DeleteObject(hpen);
	DeleteObject(hbrush);
	DeleteDC(hmemdc);
	DeleteDC(hbkdc);
}

int saverlb(HOPDB hopdb, HBITMAP hbm){
	int err;
	void *rlb;
	if((rlb = AllocRLB()) == NULL)
		return 0;
	GetBitmapBits(hbm, (unsigned)(RLBSizeX / 8) * RLBSizeY, rlb);
	err = SaveRLB(GetOPDBsIPDB(hopdb), 0, rlb);
	FreeRLB(rlb);
	return !err;
}

int saverlbsp(HOPDB hopdb, HBITMAP hbm){
	WaitCursor();
	return saverlb(hopdb, hbm);
}

int loadrlb(HIPDB hipdb, HBITMAP hbm){
	int err;
	unsigned i;
	char *cur;
	void *rlb;
	if((rlb = AllocRLB()) == NULL)
		return 0;
	err = LoadRLB(hipdb, 0, rlb);
	SetBitmapBits(hbm, (unsigned)(RLBSizeX / 8) * RLBSizeY, rlb);
	FreeRLB(rlb);
	return !err;
}

int loadrlbsp(HOPDB hopdb, HBITMAP hbm){
	WaitCursor();
	return loadrlb(GetOPDBsIPDB(hopdb), hbm);
}

int loadrlbfn(const char fn[], HBITMAP hbm){
	int err;
	HIPDB hipdb;
	WaitCursor();
	if((hipdb = LoadIPDB(fn)) == NULL)
		return 0;
	err = loadrlb(hipdb, hbm);
	ReleaseIPDB(hipdb);
	return err;
}

int iserrmoji(CHECK_LIST *chk){
	return ((chk->flag & MCF_Checked) && (chk->flag & MCF_Illegal));
}

void putbmpmax(HDC hdc, HBITMAP hbm, DWORD rop){
	HDC hmemdc;
	HBITMAP old;
	hmemdc = CreateCompatibleDC(hdc);
	old = SelectObject(hmemdc, hbm);
	SetStretchBltMode(hdc, STRETCH_ANDSCANS);
	StretchBlt(hdc, 0, 0,  GetSystemMetrics(SM_CXSCREEN),
			GetSystemMetrics(SM_CYSCREEN), hmemdc, 0, 0,
			RLBSizeX, RLBSizeY, rop);
	SelectObject(hmemdc, old);
	DeleteDC(hmemdc);
}

void stretchbmp(HDC hdc,
		HBITMAP hbm, int x, int y, int sizex, int sizey, DWORD rop){
	HDC hmemdc;
	HGDIOBJ old;
	hmemdc = CreateCompatibleDC(hdc);
	old = SelectObject(hmemdc, hbm);
	StretchBlt(hdc, x, y, sizex, sizey, hmemdc, 0, 0, RLBSizeX, RLBSizeY, rop);
	SelectObject(hmemdc, old);
	DeleteDC(hmemdc);
}

void initbmp(HBITMAP hbm){
	unsigned int i;
	char far *vram;
	if((vram = malloc((unsigned int)(RLBSizeX / 8) * RLBSizeY)) == NULL)
		return;
	for(i = 0; i < (unsigned int)(RLBSizeX / 8) * RLBSizeY; i++)
		vram[i] = 0;
	SetBitmapBits(hbm, (unsigned int)(RLBSizeX / 8) * RLBSizeY, vram);
	free(vram);
}

void putframe(HDC hdc, APPDATA *app){
	int i, xx, yy;
	OPDB_XY org, size1, size2;
	SelectObject(hdc, app->gobj.hpen[app->set.cflag ? GRAY: GREEN]);
	size1.x = (int)((long)app->set.ai.frame.size.x *
			app->set.display_reso.x / app->set.ai.display_reso.x);
	size1.y = (int)((long)app->set.ai.frame.size.y *
			app->set.display_reso.y / app->set.ai.display_reso.y);
	size2.x = (int)((long)app->set.clsw_size.x *
			app->set.display_reso.x / app->set.ai.display_reso.x);
	size2.y = (int)((long)app->set.clsw_size.y *
			app->set.display_reso.y / app->set.ai.display_reso.y);
	for(i = 0; i < app->set.frame_count; i++){
		getframeorgpos(&app->set.ai.frame, i, &org);
		xx = (int)((long)org.x *
				app->set.display_reso.x / app->set.ai.display_reso.x);
		yy = (int)((long)org.y *
				app->set.display_reso.y / app->set.ai.display_reso.y);
		BoxLine(hdc, xx, yy, xx + size1.x, yy + size1.y);
		xx = (int)((long)(org.x + app->set.clsw_pos.x)
				* app->set.display_reso.x / app->set.ai.display_reso.x);
		yy = (int)((long)(org.y + app->set.clsw_pos.y)
				* app->set.display_reso.y / app->set.ai.display_reso.y);
		BoxLine(hdc, xx, yy, xx + size2.x, yy + size2.y);
	}
}

void putstroke(HDC hdc, SETTEI *set, OPDB_XY *pt, unsigned pt_count){
	int i;
	OPDB_XY tmp, disp, in, cur;

	disp = set->display_reso;
	in = set->ai.input_reso;
	tmp.x = (int)((long)pt->x * disp.x / in.x);
	tmp.y = (int)((long)pt->y * disp.y / in.y);
	Pset(hdc, tmp.x, tmp.y);
	MoveTo(hdc, tmp.x, tmp.y);
	pt++;
	for(i = 1; i < pt_count; i++, pt++){
		cur.x = (int)((long)pt->x * disp.x / in.x);
		cur.y = (int)((long)pt->y * disp.y / in.y);
		if(cur.x != tmp.x || cur.y != tmp.y){
			LineTo(hdc, cur.x, cur.y);
			tmp = cur;
		}
	}
}

void putipd(HDC hdc, SETTEI *set, MOJI_PATTERN *mp){
	STROKE_LIST *st = mp->head;
	while(st != NULL){
		putstroke(hdc, set, st->pt, st->count);
		st = st->next;
	}
}

void codetostr(WORD code, char *buf){
	if(code > 0xff){
		buf[0] = code >> 8;
		buf[1] = code & 0xff;
		buf[2] = 0;
	}else{
		buf[0] = code;
		buf[1] = 0;
	}
}

void CharOut(HDC hdc, int x, int y, WORD ch){
	char buf[3];
	codetostr(ch, buf);
	TextOut(hdc, x, y, buf, strlen(buf));
}

void putmoji(HDC hdc, int moji, int x, int y){
	CharOut(hdc, x, y, moji);
}

void putallmoji(HDC hdc, APPDATA *app){
	int i, tmp, size;
	WORD *cur;
	CHECK_LIST **chk = NULL;
	OPDB_XY center;
	COLORREF oldc;
	SetBkMode(hdc, TRANSPARENT);
	SelectObject(hdc, app->gobj.hfont[0]);
	tmp = app->page_No * app->set.frame_count;
	cur = &app->text[tmp];
	if(app->set.chklist != NULL)
		chk = &app->set.chklist[tmp];
	oldc = SetTextColor(hdc, RGB(0, 0, 0));
	size = min(app->set.frame_count, app->moji_count - tmp);
	SelectObject(hdc, app->gobj.hpen[GRAY]);
	for(i = 0; i < size; i++, cur++){
		tmp = (chk == NULL || !iserrmoji(*chk++));
		SetTextColor(hdc, RGB(0, 0, 0));
		SelectObject(hdc, app->gobj.hbrush[tmp ? WHITE: RED]);
		getframeorgpos(&app->set.ai.frame, i, &center);
		center.x += app->set.letter_pos.x;
		center.y += app->set.letter_pos.y;
		center.x = (int)((long)center.x *
				app->set.display_reso.x / app->set.ai.display_reso.x);
		center.y = (int)((long)center.y *
				app->set.display_reso.y / app->set.ai.display_reso.y);
		Rectangle(hdc, center.x, center.y,
				center.x + app->set.letter_size.x,
				center.y + app->set.letter_size.y);
		if(chk != NULL)
			SetTextColor(hdc, tmp ? RGB(0, 0, 0): RGB(255, 255, 255));
		putmoji(hdc, *cur, center.x, center.y);
	}
	SetTextColor(hdc, oldc);
}

void putallipd(HDC hdc, APPDATA *app){
	int i;
	MOJI_PATTERN *mp = app->mp;
	for(i = 0; i < app->set.frame_count; i++){
		SelectObject(hdc, app->gobj.hpen[app->set.cflag ? BLACK: GREEN]);
		putipd(hdc, &app->set, mp++);
	}
}

void putnoisemargin(HWND hwnd, HDC hdc, APPDATA *app){
	RECT rc;
	GetClientRect(hwnd, &rc);
	SelectObject(hdc, app->gobj.hpen[CYAN]);
	SelectObject(hdc, app->gobj.hbrush[CYAN]);
	Rectangle(hdc, 0, 0, rc.right, app->set.n_margin);
	if(app->page_count > 1)
		Rectangle(hdc, rc.right - app->set.n_margin, 0, rc.right, rc.bottom);
}

void paintproc(HDC hdc, APPDATA *app){
	putframe(hdc, app);
	putallmoji(hdc, app);
	putallipd(hdc, app);
}

void chgdisppt(SETTEI *set, OPDB_XY *pt){
	pt->x = (int)((long)pt->x *
			set->display_reso.x / set->ai.display_reso.x);
	pt->y = (int)((long)pt->y *
			set->display_reso.y / set->ai.display_reso.y);
}

int chkclsw(SETTEI *set, POINT *pt){
	int n, m;
	OPDB_XY tmp, clsw_pos, clsw_size;
	FRAME frm;
	frm = set->ai.frame;
	chgdisppt(set, &frm.start);
	chgdisppt(set, &frm.step);
	clsw_pos = set->clsw_pos;
	chgdisppt(set, &clsw_pos);
	clsw_size = set->clsw_size;
	chgdisppt(set, &clsw_size);
	tmp.x = frm.start.x + clsw_pos.x;
	tmp.y = frm.start.y + clsw_pos.y;
	if(pt->x < tmp.x || pt->y < tmp.y)
		return -1;
	n = (pt->x - tmp.x) / frm.step.x;
	m = (pt->y - tmp.y) / frm.step.y;
	if(n >= frm.count.x || m >= frm.count.y)
		return -1;
	if(pt->x - n * frm.step.x - tmp.x > clsw_size.x ||
			pt->y - m * frm.step.y - tmp.y > clsw_size.y)
		return -1;
	return m * frm.count.x + n;
}

void updaterect(RECT *rc, POINT *pt){
	if(pt->x > rc->right)
		rc->right = pt->x;
	else if(pt->x < rc->left)
		rc->left = pt->x;
	if(pt->y > rc->bottom)
		rc->bottom = pt->y;
	else if(pt->y < rc->top)
		rc->top = pt->y;
}

void iptodp(SETTEI *set, POINT *pt){
	pt->x = (int)((long)pt->x * set->display_reso.x / set->ai.input_reso.x);
	pt->y = (int)((long)pt->y * set->display_reso.y / set->ai.input_reso.y);
}

void iptoip(SETTEI *set, POINT *pt){
	pt->x = (int)((long)pt->x * set->ai.input_reso.x / set->input_reso.x);
	pt->y = (int)((long)pt->y * set->ai.input_reso.y / set->input_reso.y);
}

void iptoipxy(SETTEI *set, OPDB_XY *pt){
	pt->x = (int)((long)pt->x * set->ai.input_reso.x / set->input_reso.x);
	pt->y = (int)((long)pt->y * set->ai.input_reso.y / set->input_reso.y);
}

OPDB_XY *getstrokepen(HWND hwnd,
		HDC hdc, SETTEI *set, UINT *pc, RECT *rc, UINT bevent){
	UINT i, pt_count, pe1, pe2;
	long tmp;
	POINT pt, old, dold, ofs, *cur, *tmp1;
	OPDB_XY *stroke, *tmp2;
	MSG msg;
	STROKEINFO si;

	ofs.x = ofs.y = 0;
	ClientToScreen(hwnd, &ofs);
	ofs.x = (int)((long)ofs.x * set->input_reso.x / set->display_reso.x);
	ofs.y = (int)((long)ofs.y * set->input_reso.y / set->display_reso.y);
	lpGetPenHwEventData(bevent, bevent, &pt, NULL, 1, &si);
	old = pt;
	pe1 = bevent;
	pt.x -= ofs.x;
	pt.y -= ofs.y;
	iptoip(set, &pt);
	iptodp(set, &pt);
	Pset(hdc, pt.x, pt.y);
	rc->left = rc->right = pt.x;
	rc->top = rc->bottom = pt.y;
	MoveTo(hdc, pt.x, pt.y);
	dold = pt;
	pt_count = 1;
	for(;;){
		GetMessage(&msg, hwnd, WM_MOUSEFIRST, WM_MOUSELAST);
		if(lpIsPenEvent(msg.message, tmp = GetMessageExtraInfo())){
			pe2 = (UINT)LOWORD(tmp);
			lpGetPenHwEventData(pe1, pe2, &pt, NULL, 1, &si);
			if((cur = malloc(si.cPnt * sizeof(POINT))) == NULL)
				return NULL;
			lpGetPenHwEventData(pe1, pe2, cur, NULL, si.cPnt, &si);
			for(i = 0, tmp1 = cur; i < si.cPnt; i++, tmp1++){
				if(old.x != tmp1->x || old.y != tmp1->y || set->ai.over_point){
					old = *tmp1;
					tmp1->x -= ofs.x;
					tmp1->y -= ofs.y;
					iptoip(set, tmp1);
					iptodp(set, tmp1);
					if(dold.x != tmp1->x || dold.y != tmp1->y){
						LineTo(hdc, tmp1->x, tmp1->y);
						updaterect(rc, tmp1);
						dold = *tmp1;
					}
					pt_count++;
				}
			}
			free(cur);
			pe1 = pe2;
			if(msg.message == WM_LBUTTONUP)
				break;
		}
	}
	lpGetPenHwEventData(bevent, pe2, &pt, NULL, 1, &si);
	if((tmp1 = cur = malloc((si.cPnt + 1) * sizeof(POINT))) == NULL)
		return NULL;
	pe1 = si.cPnt;
	lpGetPenHwEventData(bevent, bevent, cur, NULL, 1, &si);
	lpGetPenHwEventData(bevent, pe2, &cur[1], NULL, pe1, &si);
	if((tmp2 = stroke = malloc(pt_count * sizeof(*stroke))) != NULL){
		old.x = cur->x + 1;
		old.y = cur->y + 1;
		for(i = 0; i <= si.cPnt; i++, tmp1++){
			if(old.x != tmp1->x || old.y != tmp1->y || set->ai.over_point){
				tmp2->x = tmp1->x - ofs.x;
				tmp2->y = tmp1->y - ofs.y;
				iptoipxy(set, tmp2);
				tmp2++;
				old = *tmp1;
			}
		}
		*pc = pt_count;
	}else
		*pc = 0;
	free(cur);
	return stroke;
}

void freeplist(void *pl){
	struct tagPLIST{
		OPDB_XY pt[256];
		struct tagPLIST *next;
	} *plist, *tmp;
	plist = pl;
	while(plist != NULL){
		tmp = plist->next;
		free(plist);
		plist = tmp;
	}
}

OPDB_XY *getstrokems(
		HWND hwnd, HDC hdc, SETTEI *set, UINT *pc, RECT *rc, POINT *fpt){
	UINT i, cur_count, pt_count;
	POINT pt, old;
	OPDB_XY *stroke, *cur, *tmp;
	struct tagPLIST{
		OPDB_XY pt[256];
		struct tagPLIST *next;
	} *plist, *cur_list, *tmp_list;
	if((cur_list = plist = malloc(sizeof(*plist))) == NULL)
		return NULL;
	cur_list->next = NULL;
	rc->right = rc->left = fpt->x;
	rc->top = rc->bottom = fpt->y;
	pt = *fpt;
	Pset(hdc, pt.x, pt.y);
	MoveTo(hdc, pt.x, pt.y);
	cur_count =1;
	pt_count = 1;
	cur = cur_list->pt;
	cur->x = pt.x;
	cur->y = pt.y;
	cur++;
	old = pt;
	*pc = 0;
	for(;;){
		GetCursorPos(&pt);
		ScreenToClient(hwnd, &pt);
		if(pt.x != old.x || pt.y != old.y){
			updaterect(rc, &pt);
			LineTo(hdc, pt.x, pt.y);
			pt_count++;
			if(cur_count++ >= AC(cur_list->pt)){
				if((tmp_list = malloc(sizeof(*tmp_list))) == NULL){
					freeplist(plist);
					return NULL;
				}
				cur_list->next = tmp_list;
				cur_list = tmp_list;
				cur_list->next = NULL;
				cur = cur_list->pt;
				cur_count = 1;
			}
			cur->x = pt.x;
			cur->y = pt.y;
			cur++;
			old = pt;
		}
		if(!(GetAsyncKeyState(VK_LBUTTON) & 0x8000))
			break;
	}
	if((cur = stroke = malloc(sizeof(*stroke) * pt_count)) != NULL){
		cur_list = plist;
		cur_count = 0;
		while(cur_list != NULL){
			tmp = cur_list->pt;
			for(i = 0; i < AC(cur_list->pt) &&
					cur_count < pt_count; i++, cur_count++){
				*cur = *tmp++;
				iptoipxy(set, cur++);
			}
			cur_list = cur_list->next;
		}
		freeplist(plist);
		*pc = pt_count;
	}
	return stroke;
}

void chgerrstate(CHECK_LIST *chk, int flag, int err_kind){
	if((chk->flag & MCF_Checked) && chk->err_kind == EK_Comment)
		cfree(chk->data.comment);
	memset(&chk->data, 0, sizeof(chk->data));
	chk->err_kind = flag ? err_kind: 0;
	chk->flag &= ~MCF_Illegal;
	chk->flag |= flag;
}

int inmargin(HWND hwnd, APPDATA *app, POINT *fpt){
	RECT rc;
	GetClientRect(hwnd, &rc);
	if(fpt->y <= app->set.n_margin || (app->page_count > 1 &&
			fpt->x >= rc.right - app->set.n_margin))
		return 1;
	return 0;
}

void drawscrn(HWND hwnd, HDC hdc, APPDATA *app, POINT *fpt){
	int n;
	long tmp;
	unsigned pt_count;
	OPDB_XY pt, *pbuf;
	RECT rect;
	SETTEI *set = &app->set;
	MOJI_PATTERN *mp = app->mp;

	if(!set->cflag)
		return;
	if(inmargin(hwnd, app, fpt))
		return;
	SelectObject(hdc, app->gobj.hpen[BLACK]);
	SelectObject(hdc, app->gobj.hbrush[BLACK]);
	if((n = chkclsw(set, fpt)) < 0){
		SetCapture(hwnd);
		if(hpenwin != NULL &&
				lpIsPenEvent(WM_LBUTTONDOWN, tmp = GetMessageExtraInfo()))
			pbuf = getstrokepen(hwnd,
					hdc, set, &pt_count, &rect, (UINT)LOWORD(tmp));
		else
			pbuf = getstrokems(hwnd, hdc, set, &pt_count, &rect, fpt);
		ReleaseCapture();
		if(pbuf == NULL){
			nomemproc(hwnd);
			return;
		}
		pt.x = (rect.left + rect.right) / 2;
		pt.y = (rect.top + rect.bottom) / 2;
		n = getnearframeno(&set->ai.frame, &pt);
		if(n < 0){
			MOJI_PATTERN mp_tmp;
			STROKE_LIST st_tmp;
			st_tmp.pt = pbuf;
			st_tmp.count = pt_count;
			st_tmp.next = NULL;
			mp_tmp.head = &st_tmp;
			mp_tmp.tail = &st_tmp.next;
			SelectObject(hdc, app->gobj.hpen[WHITE]);
			putipd(hdc, set, &mp_tmp);
			InvalidateRect(hwnd, &rect, FALSE);
			return;
		}
		if(set->chklist != NULL && (tmp = app->page_No *
				set->frame_count + n) < app->moji_count){
			CHECK_LIST *chk = set->chklist[tmp];
			chgerrstate(chk, 0, 0);
		}
		if(addmpstroke(&mp[n], pbuf, pt_count)){
			free(pbuf);
			nomemproc(hwnd);
			return;
		}
	}else{
		if(set->chklist != NULL && (tmp =
				app->page_No * set->frame_count + n) < app->moji_count){
			chgerrstate(set->chklist[tmp], MCF_Illegal, EK_Space);
		}
		SelectObject(hdc, app->gobj.hpen[WHITE]);
		putipd(hdc, set, &mp[n]);
		initmp(&mp[n]);
		InvalidateRect(hwnd, NULL, FALSE);
	}
	app->renew = TRUE;
	app->update = TRUE;
}

void setpen(HPEN *pen){
	int i;
	const RGBCOL *col = _rgbtbl;
	for(i = 0;i < ColorCount;i++, col++)
		pen[i] = CreatePen(PS_SOLID, 0, RGB(col->r, col->g, col->b));
}

void delpen(HPEN *pen){
	int i;
	for(i = 0;i < ColorCount;i++)
		DeleteObject(pen[i]);
}

void setbrush(HBRUSH *brush){
	int i;
	const RGBCOL *col = _rgbtbl;
	for(i = 0;i < ColorCount;i++, col++)
		brush[i] = CreateSolidBrush(RGB(col->r, col->g, col->b));
}

void delbrush(HBRUSH *brush){
	int i;
	for(i = 0;i < ColorCount;i++)
		DeleteObject(brush[i]);
}

#define SelText			103

BOOL CALLBACK _export seltextdlg(
		HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam){
	int i, j;
	FILE_LIST far *fl;
	char tmp[sizeof(fl->fname) + sizeof(fl->explain) + 20];
	LRESULT item_No;
	static struct{
		FILE_LIST far *fl;
		char far *fname;
	} *data;

	switch(msg){
	case WM_INITDIALOG:
		data = (void far *)lParam;
		fl = data->fl;
		while(fl != NULL){
			sprintf(tmp, "%13s ... %-80s", fl->fname, fl->explain);
			SendDlgItemMessage(hdlg,
					SelText, LB_ADDSTRING, 0, (LPARAM)((LPCSTR)tmp));
			fl = fl->next;
		}
		return TRUE;
	case WM_COMMAND:
		switch(wParam){
		case IDOK:
			item_No = SendDlgItemMessage(hdlg, SelText, LB_GETCURSEL, 0, 0);
			if(item_No == LB_ERR)
				return TRUE;
			SendDlgItemMessage(hdlg, SelText,
					LB_GETTEXT, (WPARAM)item_No, (LPARAM)((LPCSTR)tmp));
			for(i = 0; tmp[i] == ' '; i++);
			for(j = i; tmp[j] != ' '; j++);
			tmp[j] = 0;
			lstrcpy(data->fname, &(tmp[i]));
			EndDialog(hdlg, 0);
			return TRUE;
		case IDCANCEL:
			EndDialog(hdlg, 1);
			return TRUE;
		}
		break;
	case WM_CLOSE:
		EndDialog(hdlg, 1);
		break;
	}
	return 0;
}

int selecttext(HWND hwnd, const FILE_LIST *fl, char far txtfile[]){
	int err;
	struct{
		const FILE_LIST far *fl;
		char far *fname;
	} tmp;

	if(fl == NULL){
		MessageBox(hwnd, "I\eLXgȂ",
				"WARNING", MB_OK | MB_ICONEXCLAMATION);
		return 1;
	}
	tmp.fl = fl;
	tmp.fname = txtfile;
	txtfile[0] = 0;
	err = OpenDialog(hwnd, "seltext", seltextdlg, (LPARAM)&tmp);
	return err;
}

int getcfgint(char file[], char group[], char key[], int def){
	return GetPrivateProfileInt(group, key, def, file);
}

void getcfgstr(char file[],
		char group[], char key[], char def[], char str[], int size){
	GetPrivateProfileString(group, key, def, str, size, file);
}

void freefilelist(FILE_LIST *fl){
	FILE_LIST *next;
	while(fl != NULL){
		next = fl->next;
		free(fl);
		fl = next;
	}
}

int getflstr(char cfg[],
		char group[], char key[], int num, char buf[], int size){
	char key_buf[20];
	wsprintf(key_buf, "%s%d", key, num);
	buf[0] = 0;
	getcfgstr(cfg, group, key_buf, buf, buf, size);
	return (buf[0] == 0);
}

FILE_LIST *getfilelist(char cfg[], char group[], char key[]){
	int i, j, err = 0;
	FILE_LIST *fl, **tail, *tmp;
	char ch, buf[sizeof(fl->fname) + sizeof(fl->explain)];

	fl = NULL;
	tail = &fl;
	for(i = 1; !getflstr(cfg, group, key, i, buf, sizeof(buf)); i++){
		if((tmp = malloc(sizeof(FILE_LIST))) == NULL){
			err = 1;
			break;
		}
		for(j = 0; buf[j] != ' ' && buf[j] != '\t' && buf[j] != 0; j++);
		ch = buf[j];
		buf[j] = 0;
		if(lstrlen(buf) >= sizeof(tmp->fname))
			buf[sizeof(tmp->fname) - 1] = 0;
		lstrcpy(tmp->fname, buf);
		tmp->explain[0] = 0;
		if(ch != 0){
			for(j++; buf[j] == ' ' || buf[j] == '\t'; j++);
			if(lstrlen(&(buf[j])) >= sizeof(tmp->explain))
				buf[j + sizeof(tmp->explain) - 1] = 0;
			lstrcpy(tmp->explain, &(buf[j]));
		}
		tmp->next = NULL;
		*tail = tmp;
		tail = &(tmp->next);
	}
	if(err){
		freefilelist(fl);
		fl = NULL;
	}
	return fl;
}

long getcfglong(char cfg[], char group[], char key[], long def){
	char buf[10];
	buf[0] = 0;
	getcfgstr(cfg, group, key, buf, buf, sizeof(buf));
	if(buf[0] == 0)
		return def;
	return atol(buf);
}

void setacparam(SETTEI *set){
	set->clsw_pos.x = 0;
	set->clsw_pos.y = set->ai.frame.size.y + 2;
	set->clsw_size.x = set->ai.frame.size.x;
	set->clsw_size.y = ClearSwitchHeight;
	set->letter_pos.x = (set->ai.frame.size.x - set->letter_size.x) / 2;
	set->letter_pos.y = - set->letter_size.y - 2;
	set->frame_count = set->ai.frame.count.x * set->ai.frame.count.y;
}

void getpeninfo(PENINFO *pi){
	HPENDATA hpd;
	PENDATAHEADER pdh;
	hpd = lpCreatePenData(NULL, -1, PDTS_ARBITRARY, 0);
	lpGetPenDataInfo(hpd, &pdh, pi, 0);
	DestroyPenData(hpd);
}

void getcfgai(SETTEI *set, char cfg[]){
	int tmp;
	char *group, zero = 0, *nul = &zero;
	memset(&(set->ai), 0, sizeof(set->ai));
	group = "User";
	getcfgstr(cfg, group,
			"Name", nul, set->ai.ad_name, sizeof(set->ai.ad_name));
	getcfgstr(cfg, group,
			"Syozoku", nul, set->ai.ad_assign, sizeof(set->ai.ad_assign));
	getcfgstr(cfg, group,
			"Mail", nul, set->ai.ad_mail, sizeof(set->ai.ad_mail));
	group = "Frame";
	set->ai.frame.size.x = getcfgint(cfg, group, "SizeX", 60);
	set->ai.frame.size.y = getcfgint(cfg, group, "SizeY", 60);
	set->ai.frame.step.x =
			getcfgint(cfg, group, "StepX", set->ai.frame.size.x * 13 / 12);
	setacparam(set);
	tmp = (set->clsw_pos.y -
			set->letter_pos.y + set->clsw_size.y) * 110 / 100;
	set->ai.frame.step.y = getcfgint(cfg, group, "StepY", tmp);
	tmp = (int)((long)(GetSystemMetrics(SM_CXSCREEN) -
			GetSystemMetrics(SM_CXVSCROLL)) *
			95 / 100) / set->ai.frame.step.x;
	set->ai.frame.count.x = getcfgint(cfg, group, "CountX", tmp);
	tmp = (int)((long)(GetSystemMetrics(SM_CYSCREEN) -
			GetSystemMetrics(SM_CYCAPTION) -
			GetSystemMetrics(SM_CYMENU)) * 95 / 100) / set->ai.frame.step.y;
	set->ai.frame.count.y = getcfgint(cfg, group, "CountY", tmp);
	tmp = ((GetSystemMetrics(SM_CXSCREEN) -
			GetSystemMetrics(SM_CXVSCROLL)) - (set->ai.frame.step.x *
			(set->ai.frame.count.x - 1) + set->ai.frame.size.x)) / 2;
	set->ai.frame.start.x = getcfgint(cfg, group, "StartX", tmp);
	tmp = ((GetSystemMetrics(SM_CYSCREEN) - GetSystemMetrics(SM_CYMENU) -
			GetSystemMetrics(SM_CYCAPTION)) - (set->ai.frame.step.y *
			(set->ai.frame.count.y - 1) + set->clsw_pos.y +
			set->clsw_size.y - set->letter_pos.y)) / 2 - set->letter_pos.y;
	set->ai.frame.start.y = getcfgint(cfg, group, "StartY", tmp);
	group = "Tablet";
	getcfgstr(cfg, group,
			"Maker", nul, set->ai.tab_maker, sizeof(set->ai.tab_maker));
	getcfgstr(cfg, group,
			"Name", nul, set->ai.tab_name, sizeof(set->ai.tab_name));
	set->ai.display_reso = set->display_reso;
	set->ai.input_reso = set->input_reso;
	set->ai.tab_size = set->tab_size;
	set->ai.sam_rate = set->srate;
	set->ai.over_point = set->over_point;
	strcpy(set->ai.tmp_name, set->template);
	setacparam(set);
}

int getcfgsys(SETTEI *set, char cfg[]){
	char *group, zero = 0, *nul = &zero;
	char buf[10];
	group = "Letter";
	set->letter_size.x = getcfgint(cfg, group, "SizeX", 20);
	set->letter_size.y = getcfgint(cfg, group, "SizeY", 20);
	getcfgstr(cfg,
			group, "Font", "lr ", set->font, sizeof(set->font));
	getcfgstr(cfg, group, "TextFile1", nul, buf, sizeof(buf));
	if((set->text_list = getfilelist(cfg, group, "TextFile")) == NULL)
		if(buf[0])
			return 1;
	group = "System";
	getcfgstr(cfg, group, "DBExt", "ipd", set->dbext, sizeof(set->dbext));
	getcfgstr(cfg, group, "DataDir", nul, set->dbdir, sizeof(set->dbdir));
	getcfgstr(cfg, group, "TemplateRLB",
			"tmplate.rlb", set->template, sizeof(set->template));
	getcfgstr(cfg, group,
			"ReadMe", "readme.txt", set->readme, sizeof(set->readme));
	set->basenum = getcfglong(cfg, group, "BaseFileNum", 0);
	set->rlbdiv = getcfgint(cfg, group, "RLBDiv", 3);
	set->deflaglimit = getcfglong(cfg, group, "DeflagLimit", 2048);
	set->over_point = getcfglong(cfg, group, "OverPoint", 1);
	set->n_margin = getcfgint(cfg, group, "NoiseMargin", 15);
	set->display_reso.x = GetSystemMetrics(SM_CXSCREEN);
	set->display_reso.y = GetSystemMetrics(SM_CYSCREEN);
	if(hpenwin == NULL){
		set->input_reso.x = set->display_reso.x;
		set->input_reso.y = set->display_reso.y;
		set->tab_size.x = 0;
		set->tab_size.y = 0;
		set->srate = 0;
	}else{
		PENINFO pi;
		getpeninfo(&pi);
		set->input_reso.x = pi.cxRawWidth;
		set->input_reso.y = pi.cyRawHeight;
		set->tab_size.x = pi.wDistinctWidth;
		set->tab_size.y = pi.wDistinctHeight;
		set->srate = pi.nSamplingRate;
	}
	return 0;
}

void writecfgint(char cfg[], char group[], char key[], int num){
	char buf[10];
	WritePrivateProfileString(group, key, itoa(num, buf, 10), cfg);
}

void writecfglong(char cfg[], char group[], char key[], long num){
	char buf[16];
	WritePrivateProfileString(group, key, ltoa(num, buf, 10), cfg);
}

void writecfgstr(char cfg[], char group[], char key[], char str[]){
	WritePrivateProfileString(group, key, str, cfg);
}

void writefilelist(char cfg[], char group[], char key[], FILE_LIST *fl){
	int i;
	char key_buf[30];
	char buf[sizeof(fl->fname) + sizeof(fl->explain)];
	for(i = 1; fl != NULL; fl = fl->next, i++){
		wsprintf(key_buf, "%s%d", key, i);
		wsprintf(buf, "%s %s", fl->fname, fl->explain);
		writecfgstr(cfg, group, key_buf, buf);
	}
}

void writecfg(SETTEI *set, char *cfg){
	char *group;
	group = "User";
	writecfgstr(cfg, group, "Name", set->ai.ad_name);
	writecfgstr(cfg, group, "Syozoku", set->ai.ad_assign);
	writecfgstr(cfg, group, "Mail", set->ai.ad_mail);
	group = "Frame";
	writecfgint(cfg, group, "StartX", set->ai.frame.start.x);
	writecfgint(cfg, group, "StartY", set->ai.frame.start.y);
	writecfgint(cfg, group, "CountX", set->ai.frame.count.x);
	writecfgint(cfg, group, "CountY", set->ai.frame.count.y);
	writecfgint(cfg, group, "StepX", set->ai.frame.step.x);
	writecfgint(cfg, group, "StepY", set->ai.frame.step.y);
	writecfgint(cfg, group, "SizeX", set->ai.frame.size.x);
	writecfgint(cfg, group, "SizeY", set->ai.frame.size.y);
	group = "Letter";
	writecfgint(cfg, group, "SizeX", set->letter_size.x);
	writecfgint(cfg, group, "SizeY", set->letter_size.y);
	writecfgstr(cfg, group, "Font", set->font);
	writefilelist(cfg, group, "TextFile", set->text_list);
	group = "Tablet";
	writecfgstr(cfg, group, "Maker", set->ai.tab_maker);
	writecfgstr(cfg, group, "Name", set->ai.tab_name);
	group = "System";
	writecfgstr(cfg, group, "DBExt", set->dbext);
	writecfgstr(cfg, group, "DataDir", set->dbdir);
	writecfgstr(cfg, group, "TemplateRLB", set->template);
	writecfglong(cfg, group, "BaseFileNum", set->basenum);
	writecfgint(cfg, group, "RLBDiv", set->rlbdiv);
	writecfglong(cfg, group, "DeflagLimit", set->deflaglimit);
	writecfgstr(cfg, group, "ReadMe", set->readme);
	writecfgint(cfg, group, "OverPoint", set->over_point);
	writecfgint(cfg, group, "NoiseMargin", set->n_margin);
}

#define RM_TextBox		100

char *loadreadme(FILE *fp){
	char *buf, *cur;
	int ch;
	long sz;
	fseek(fp, 0, SEEK_END);
	sz = ftell(fp) * 2;
	if((cur = buf = malloc(sz)) != NULL){
		fseek(fp, 0, SEEK_SET);
		while((ch = fgetc(fp)) != EOF){
			if(ch == '\n')
				*cur++ = '\r';
			*cur++ = ch;
			if(IsKanji(ch))
				*cur++ = fgetc(fp);
		}
	}
	if(sz > 0)
		*cur = 0;
	return buf;
}

int setreadme(HWND hwnd, char far *fname){
	int err = 0;
	char *buf;
	FILE *fp;
	if((fp = fopen(fname, "r")) == NULL)
		return 1;
	if((buf = loadreadme(fp)) != NULL){
		SetDlgItemText(hwnd, RM_TextBox, buf);
		free(buf);
	}else
		err = 1;
	fclose(fp);
	return err;
}

void centerdlg(HWND hwnd){
	RECT rc;
	GetWindowRect(hwnd, &rc);
	SetWindowPos(hwnd, 0,
			(GetSystemMetrics(SM_CXSCREEN) - (rc.right - rc.left)) / 2,
			(GetSystemMetrics(SM_CYSCREEN) - (rc.bottom - rc.top)) / 2,
			0, 0, SWP_NOSIZE | SWP_NOZORDER);
}

#pragma argsused

BOOL CALLBACK _export ReadMeDlg(
		HWND hdlg, UINT wMsg, WPARAM wParam, LPARAM lParam){
	switch(wMsg){
	case WM_INITDIALOG:
		if(setreadme(hdlg, (char far *)lParam))
			EndDialog(hdlg, IDOK);
		centerdlg(hdlg);
		return TRUE;
	case WM_COMMAND:
		switch(wParam){
		case IDOK:
		case IDCANCEL:
			EndDialog(hdlg, wParam);
			return TRUE;
		}
		break;
	case WM_CLOSE:
		EndDialog(hdlg, IDCANCEL);
		return TRUE;
	}
	return 0;
}

#define DSnx			0x00990066l
#define Sn				0x00330008l
#define DSo				0x00EE0086l
#define DSx				0x00660046l

int saveaddinfo(HOPDB hOpdb, SET_AI *src_ai){
	int err, size;
	HAIFMT dst_haif;
	void *buf;

	if((dst_haif = GetOPDBAddInfoFormat(hOpdb, AIF_Set)) == NULL)
		return 1;
	size = GetAddInfoSize(dst_haif);
	if(size == 0)
		return 0;
	if((buf = malloc(size)) == NULL){
		ReleaseAddInfoFormat(dst_haif);
		return 1;
	}
	LoadOPDBAddInfo(hOpdb, 0, buf, size);
	MakeSetAI(AI_ToBuf, dst_haif, buf, src_ai);
	ReleaseAddInfoFormat(dst_haif);
	err = SaveOPDBAddInfo(hOpdb, 0, buf, size);
	free(buf);
	return err;
}

int loadaddinfo(HOPDB hOpdb, SET_AI *dst_ai){
	int err, size;
	HAIFMT haif;
	void *buf;

	if((haif = GetOPDBAddInfoFormat(hOpdb, AIF_Set)) == NULL)
		return 1;
	size = GetAddInfoSize(haif);
	if(size == 0)
		return 0;
	if((buf = malloc(size)) == NULL){
		ReleaseAddInfoFormat(haif);
		return 1;
	}
	err = LoadOPDBAddInfo(hOpdb, 0, buf, size);
	MakeSetAI(AI_ToVar, haif, buf, dst_ai);
	free(buf);
	ReleaseAddInfoFormat(haif);
	return err;
}

HAIFMT MakePageAIF(int frame_count){
	return CreateAddInfoFormat();
}

HAIFMT MakeStrokeAIF(void){
	HAIFMT haif;
	if((haif = CreateAddInfoFormat()) == NULL)
		return NULL;
	if(AddAddInfoItem(haif, "tag No", IT_Word, 1)){
		ReleaseAddInfoFormat(haif);
		return NULL;
	}
	return haif;
}

HOPDB createmdbsp(SETTEI *set, char *dbfile, unsigned page_count){
	int err;
	HOPDB hOpdb = NULL;
	HAIFMT set_aif, page_aif, stroke_aif;

	WaitCursor();
	err = (set_aif = MakeSetAI(AI_AddItem, NULL, NULL, &set->ai)) == NULL;
	err |= (page_aif = MakePageAIF(set->frame_count)) == NULL;
	err |= (stroke_aif = MakeStrokeAIF()) == NULL;
	if(!err){
		hOpdb = CreateOPDB(dbfile,
				set_aif, page_aif, stroke_aif, NULL, page_count);
		if((err = MakeRLBIndex(GetOPDBsIPDB(hOpdb), 1)) != 0){
			ReleaseOPDB(hOpdb);
			hOpdb = NULL;
			remove(dbfile);
		}
	}
	ReleaseAddInfoFormat(set_aif);
	ReleaseAddInfoFormat(page_aif);
	ReleaseAddInfoFormat(stroke_aif);
	return hOpdb;
}

int saveheadsp(HOPDB hOpdb, void *add_info){
	int err;
	WaitCursor();
	err = saveaddinfo(hOpdb, add_info);
	return err;
}

int loadheadsp(HOPDB hOpdb, void *add_info){
	int err;
	WaitCursor();
	err = loadaddinfo(hOpdb, add_info);
	return err;
}

int arrangemdbsp(HOPDB hOpdb){
	WaitCursor();
	return ArrangeOPDB(hOpdb);
}

int savepagesp(HOPDB hOpdb, int page_No, MOJI_PATTERN *mp, int frame_count){
	WaitCursor();
	return savemparray(hOpdb, page_No, mp, frame_count);
}

MOJI_PATTERN *loadpagesp(SETTEI *set, HOPDB hOpdb, int page_No){
	WaitCursor();
	return loadmparray(hOpdb, page_No, &set->ai.frame,
			&set->ai.input_reso, &set->ai.display_reso);
}

int loadpageex(SETTEI *set, HOPDB hOpdb, int page_No, MOJI_PATTERN **mp){
	MOJI_PATTERN *tmp;
	if((tmp = loadpagesp(set, hOpdb, page_No)) == NULL)
		return 1;
	if(*mp != NULL)
		freemparray(*mp, set->frame_count);
	*mp = tmp;
	return 0;
}

void filemiss(HWND hwnd){
	MessageBox(hwnd, "t@CG[", "Error !", MB_OK | MB_ICONEXCLAMATION);
}

int getfilenum(const char *fn){
	int cnt;
	struct ffblk fb;
	if(findfirst(fn, &fb, FA_ARCH | FA_RDONLY) < 0)
		return 0;
	for(cnt=0;;){
		cnt++;
		if(findnext(&fb) < 0)
			break;
	}
	return cnt;
}

WORD *ldtextex(HWND hwnd, char fname[]){
	WORD *text;
	if((text = loadtext(fname)) == NULL){
		MessageBox(hwnd, "̓eLXgt@C̓Ǎ݂Ɏs",
				"Error !", MB_OK | MB_ICONEXCLAMATION);
		return NULL;
	}
	if(textlen(text) < 1){
		free(text);
		MessageBox(hwnd, "̓eLXg͍ŒꕶȏKv",
				"Error !", MB_OK | MB_ICONEXCLAMATION);
		return NULL;
	}
	return text;
}

void setfont(SETTEI *set, HFONT *hf){
	hf[0] = MakeFont(set->font, set->letter_size.x, set->letter_size.y, 0);
	hf[1] = MakeFont("Times New Roman",
			GetSystemMetrics(SM_CXSCREEN) * 3 / 20,
			GetSystemMetrics(SM_CYSCREEN) / 5, 0);
}

void CopyTempBmp(HBITMAP name_bmp, HBITMAP tmp_bmp){
	HDC hsrc, hdest;
	HGDIOBJ old1, old2;
	hsrc = CreateCompatibleDC(NULL);
	hdest = CreateCompatibleDC(NULL);
	old1 = SelectObject(hsrc, name_bmp);
	old2 = SelectObject(hdest, tmp_bmp);
	SetStretchBltMode(hdest, STRETCH_ANDSCANS);
	StretchBlt(hdest, 0, 0, GetSystemMetrics(SM_CXSCREEN),
			GetSystemMetrics(SM_CYSCREEN), hsrc, 0, 0,
			RLBSizeX, RLBSizeY, Sn);
	SelectObject(hsrc, old1);
	SelectObject(hdest, old2);
	DeleteDC(hsrc);
	DeleteDC(hdest);
}

void putmoyou(HWND hwnd, HDC hdc){
	RECT rc;
	int i, tmp, y, sx, sy;
	HPEN pen, old;
	enum{ LineNum = 40 };
	GetClientRect(hwnd, &rc);
	sx = rc.right - rc.left;
	sy = rc.bottom - rc.top;
	pen = CreatePen(PS_SOLID, 0, RGB(192, 192, 192));
	old = SelectObject(hdc, pen);
	for(i = 0; i < LineNum; i++){
		tmp = (long)sx * i / LineNum;
		y = (long)sy * i / LineNum;
		MoveTo(hdc, tmp, rc.bottom);
		LineTo(hdc, rc.right, rc.bottom - y);
		LineTo(hdc, rc.right - tmp, rc.top);
		LineTo(hdc, rc.left, y);
		LineTo(hdc, tmp, rc.bottom);
	}
	SelectObject(hdc, old);
	DeleteObject(pen);
}

void puttitle(HWND hwnd, HDC hdc, DRAWTOOL *gobj){
	int i, j, k;
	int sx, sy;
	RECT rc, tmp;
	char *title;
	DWORD size;
	enum{ SlideRateX = 160, SlideRateY = 120 };
	putmoyou(hwnd, hdc);
	SetBkMode(hdc, TRANSPARENT);
	SelectObject(hdc, gobj->hfont[1]);
	GetClientRect(hwnd, &rc);
	sx = rc.right - rc.left;
	sy = rc.bottom - rc.top;
	title = "Please Challenge";
	for(i = 0; i < 2; i++){
		j = 1 - i * 2;
		k = 127 * i;
		SetTextColor(hdc, RGB(k, k, k));
		tmp.left = 0;
		tmp.top = 0;
		tmp.right = sx - sx * 2 / SlideRateX;
		DrawText(hdc, title, -1, &tmp,
				DT_CALCRECT | DT_CENTER | DT_WORDBREAK);
		tmp.right -= tmp.left;
		tmp.bottom -= tmp.top;
		rc.left = (sx - tmp.right) / 2 + j * sx / SlideRateX;
		rc.right = rc.left + tmp.right;
		rc.top = (sy - tmp.bottom) / 2 + j * sy / SlideRateY;
		rc.bottom = rc.top + tmp.bottom;
		DrawText(hdc, title, -1, &rc, DT_CENTER | DT_WORDBREAK);
	}
}

void putrlbtile(HDC hdc, SETTEI *set,
		void *rlblist, int rlb_count, int page_No, HBITMAP name_bmp){
	int i, tile_count = set->rlbdiv * set->rlbdiv;
	int x, y, sx, sy, rx, ry, len;
	char *tmp;
	struct{
		char fname[MAXFILE + MAXEXT - 1];
	} *rlb = rlblist;
	char fn[MAXFILE];
	DWORD ex;

	sx = GetSystemMetrics(SM_CXSCREEN);
	sy = GetSystemMetrics(SM_CYSCREEN);
	rx = (int)((long)sx *
			(ry = sy - GetSystemMetrics(SM_CYMENU) -
			GetSystemMetrics(SM_CYCAPTION)) / sy);
	SetStretchBltMode(hdc, STRETCH_ORSCANS);
	for(i = 0; i < tile_count; i++){
		if(page_No * tile_count + i >= rlb_count)
			break;
		fnsplit(tmp =
				rlb[page_No * tile_count + i].fname, NULL, NULL, fn, NULL);
		{
			char buf[MAXPATH];
			fnmerge(buf, NULL, set->dbdir, fn, set->dbext);
			loadrlbfn(buf, name_bmp);
		}
		stretchbmp(hdc, name_bmp,
				x = (i % set->rlbdiv) * rx / set->rlbdiv + (sx - rx) / 2,
				y = (i / set->rlbdiv) * ry / set->rlbdiv,
				rx / set->rlbdiv, ry / set->rlbdiv, Sn);
		BoxLine(hdc, x + 1, y + 1,
				x + rx / set->rlbdiv - 1, y + ry / set->rlbdiv - 1);
		len = lstrlen(tmp);
		ex = GetTextExtent(hdc, tmp, len);
		TextOut(hdc, x + 2, y + ry / set->rlbdiv - HIWORD(ex) - 1, tmp, len);
	}
}

void putpageno(HWND hwnd, int page_No, int page_count){
	char buf[80];
	wsprintf(buf, "%s   <<< page %3d/%3d >>>",
			_titletext, page_No + 1, page_count);
	SetWindowText(hwnd, buf);
}

HWND pagenownd(HWND parent, HWND msg, int page_no){
	POINT pt, sz;
	char buf[40];
	sprintf(buf, "߰ޔԍ %d", page_no);
	{
		HDC hdc;
		DWORD te;
		RECT rc;
		POINT mpt;
		hdc = GetDC(parent);
		te = GetTextExtent(hdc, buf, strlen(buf));
		ReleaseDC(parent, hdc);
		sz.x = LOWORD(te) + 8 + GSM(SM_CXBORDER) * 2;
		sz.y = HIWORD(te) + 2 + GSM(SM_CYBORDER) * 2;
		GetWindowRect(parent, &rc);
		GetCursorPos(&mpt);
		pt.x = rc.right - sz.x - GSM(SM_CXVSCROLL);
		pt.y = mpt.y - sz.y / 2;
	}
	if(msg == NULL){
		msg = CreateWindow("static", buf,
				WS_VISIBLE | SS_CENTER | WS_BORDER | WS_POPUP,
				pt.x, pt.y, sz.x, sz.y, parent, NULL,
				WtoI(parent), NULL);
	}else{
		SetWindowPos(msg,
				NULL, pt.x, pt.y, sz.x, sz.y, SWP_NOZORDER);
		SendMessage(msg, WM_SETTEXT, 0, (LPARAM)buf);
	}
    return msg;
}

int getscrollpage(HWND hwnd, WPARAM wp, LPARAM lParam){
	int newpos = GetScrollPos(hwnd, SB_VERT);
	int min_page, max_page;
#ifdef __WIN32__
	int pos = (SHORT)HIWORD(wp);
	int cmd = LOWORD(wp);
#else
	int pos = LOWORD(lParam);
	int cmd = wp;
#endif
	static HWND msg = NULL;
	GetScrollRange(hwnd, SB_VERT, &min_page, &max_page);
	switch(cmd){
	case SB_PAGEDOWN:
	case SB_LINEDOWN:
		if(++newpos > max_page)
			return max_page;
		break;
	case SB_PAGEUP:
	case SB_LINEUP:
		if(--newpos < min_page)
			return min_page;
		break;
	case SB_THUMBPOSITION:
		if(msg != NULL){
			DestroyWindow(msg);
			msg = NULL;
		}
		newpos = pos;
		break;
	case SB_THUMBTRACK:
		msg = pagenownd(hwnd, msg, pos + 1);
		putpageno(hwnd, pos, max_page + 1);
		break;
	}
	return newpos;
}

void setdrawtool(SETTEI *set, DRAWTOOL *gobj){
	setfont(set, gobj->hfont);
	setpen(gobj->hpen);
	setbrush(gobj->hbrush);
}

void unsetdrawtool(DRAWTOOL *gobj){
	delpen(gobj->hpen);
	delbrush(gobj->hbrush);
	DeleteObject(gobj->hfont[0]);
	DeleteObject(gobj->hfont[1]);
}

void putnamebmp(HDC hdc, HBITMAP name_bmp, HBITMAP tmp_bmp){
	HDC hmemdc;
	HGDIOBJ old;
	hmemdc = CreateCompatibleDC(hdc);
	old = SelectObject(hmemdc, tmp_bmp);
	BitBlt(hdc, 0, 0, GetSystemMetrics(SM_CXSCREEN),
			GetSystemMetrics(SM_CYSCREEN), hmemdc, 0, 0, SRCCOPY);
	SelectObject(hmemdc, old);
	DeleteDC(hmemdc);
	putbmpmax(hdc, name_bmp, DSx);
}

void getnewfname(SETTEI *set, char fn[]){
	char buf[MAXFILE + MAXEXT - 1];
	MakeNewFileName(set->dbdir, set->dbext, set->basenum, buf);
	fnsplit(buf, NULL, NULL, fn, NULL);
}

HOPDB createnewfile(SETTEI *set, int page_count){
	char dbfile[MAXPATH], fn[MAXFILE];
	getnewfname(set, fn);
	fnmerge(dbfile, NULL, set->dbdir, fn, set->dbext);
	return createmdbsp(set, dbfile, page_count);
}

void getnowday(HIZUKE *day){
	struct date now;
	getdate(&now);
	day->year = now.da_year;
	day->month = now.da_mon;
	day->day = now.da_day;
}

void getnowtime(JIKOKU *tm){
	struct time now;
	gettime(&now);
	tm->hour = now.ti_hour;
	tm->minute = now.ti_min;
	tm->second = now.ti_sec;
}

void UnsetCFG(SETTEI *set){
	freefilelist(set->text_list);
}

int getcfgfile(SETTEI *set, char cfg[]){
	int err;
	if((err = getcfgsys(set, cfg)) == 0)
		getcfgai(set, cfg);
	return err;
}

void getcfgname(HINSTANCE hInstance, char cfg[]){
	char dr[MAXDRIVE], di[MAXDIR], fn[MAXFILE];
	GetModuleFileName(hInstance, cfg, MAXPATH);
	fnsplit(cfg, dr, di, fn, NULL);
	fnmerge(cfg, dr, di, fn, ".ini");
}

int SetCFG(HINSTANCE hInstance, SETTEI *set){
	int exist;
	char buf[MAXPATH];
	getcfgname(hInstance, buf);
	if(getcfgfile(set, buf)){
		UnsetCFG(set);
		return 1;
	}
	writecfg(set, buf);
	return 0;
}

void setcfgai(HINSTANCE hInstance, SETTEI *set){
	char cfg[MAXPATH];
	getcfgname(hInstance, cfg);
	getcfgai(set, cfg);
}

void setmenuitem(HMENU hmenu, int cmd, int flag){
	EnableMenuItem(hmenu, cmd, MF_BYCOMMAND | flag ? MF_ENABLED: MF_GRAYED);
}

void setmenu(HWND hwnd, APPDATA *app){
	int flag;
	int mode = app->mode,
			page_No = app->page_No, page_count = app->page_count;
	HMENU hmenu;
	hmenu = GetMenu(hwnd);
	flag = (mode == WriteMoji && page_No >= 0) ||
			(mode == SelectName && page_No > 0);
	setmenuitem(hmenu, WC_Prev, flag);
	flag = mode == WriteMoji ||
			(mode == SelectName && page_No < page_count - 1);
	setmenuitem(hmenu, WC_Next, flag);
	setmenuitem(hmenu, WC_Clear,
			mode == WriteMoji && (app->set.cflag || app->page_No < 0));
	setmenuitem(hmenu, WC_New, mode == PutTitle);
	setmenuitem(hmenu, WC_Continue, mode == PutTitle);
	setmenuitem(hmenu, WC_Stop, mode != PutTitle);
	setmenuitem(hmenu, WC_NextModify,
			(mode == WriteMoji && app->set.chklist != NULL));
	setmenuitem(hmenu, WC_PrevModify,
			(mode == WriteMoji && app->set.chklist != NULL));
	DrawMenuBar(hwnd);
}

int getselname(SETTEI *set, int page_No, int rlb_count, POINT *pt){
	int sx, sy, rx, ry, n, tmp;
	sx = GetSystemMetrics(SM_CXSCREEN);
	sy = GetSystemMetrics(SM_CYSCREEN);
	rx = (int)((long)sx * (ry = sy - GetSystemMetrics(SM_CYMENU) -
			GetSystemMetrics(SM_CYCAPTION)) / sy);
	if(pt->x < (sx - rx) / 2 || pt->x > sx - (sx - rx) / 2)
		return -1;
	n = pt->y / (ry / set->rlbdiv);
	if(n >= set->rlbdiv)
		n = set->rlbdiv - 1;
	n *= set->rlbdiv;
	tmp = (pt->x - (sx - rx) / 2) / (rx / set->rlbdiv);
	if(tmp >= set->rlbdiv)
		tmp = set->rlbdiv - 1;
	n += tmp;
	if((tmp = page_No * set->rlbdiv * set->rlbdiv + n) >= rlb_count)
		return -1;
	return tmp;
}

HOPDB loadmdbsp(SETTEI *set, char fname[]){
	char buf[MAXPATH];
	WaitCursor();
	fnmerge(buf, NULL, set->dbdir, fname, set->dbext);
	return LoadOPDB(buf);
}

void *getrlblist(SETTEI *set, int *rlb_count){
	int i;
	char fn[MAXPATH];
	struct{
		char fname[MAXFILE + MAXEXT - 1];
	} *rlblist;
	struct ffblk fb;

	fnmerge(fn, NULL, set->dbdir, "*", set->dbext);
	*rlb_count = getfilenum(fn);
	if(*rlb_count == 0){
		MessageBox(NULL, "f[^t@CȂ",
				"mF", MB_OK | MB_ICONINFORMATION);
		return NULL;
	}
	if((rlblist = malloc(sizeof(*rlblist) * *rlb_count)) == NULL){
		nomemproc(NULL);
		return NULL;
	}
	findfirst(fn, &fb, FA_ARCH | FA_RDONLY);
	i = 0;
	do{
		lstrcpy(rlblist[i++].fname, fb.ff_name);
	}while(!findnext(&fb));
	return rlblist;
}

int readmedlg(HWND hwnd, const char *fn){
	return OpenDialog(hwnd, "readme", ReadMeDlg, (LPARAM)fn);
}

int selfont(SETTEI *set, POINT *pt){
	int n, limit;
	FRAME frm;
	OPDB_XY lpos;
	frm = set->ai.frame;
	chgdisppt(set, &frm.step);
	chgdisppt(set, &frm.size);
	chgdisppt(set, &frm.start);
	lpos = set->letter_pos;
	chgdisppt(set, &lpos);
	limit = frm.start.y + lpos.y;
	if(pt->y > limit && pt->y < limit + frm.step.y *
			(frm.count.y - 1) + set->letter_size.y - 1){
		n = (pt->y - limit) / frm.step.y * frm.count.x;
		if((pt->y - limit) % frm.step.y >= set->letter_size.y)
			return -1;
	}else
		return -1;
	limit = frm.start.x + lpos.x;
	if(pt->x > limit && pt->x < limit + frm.step.x *
			(frm.count.x - 1) + set->letter_size.x - 1){
		n += (pt->x - limit) / frm.step.x;
		if((pt->x - limit) % frm.step.x >= set->letter_size.x)
			return -1;
	}else
		return -1;
	return n;
}

typedef struct{
	UINT code;
	char str[80];
	APPDATA *app;
} MSGBOX;

void paintmb(HWND hwnd, MSGBOX *mb){
	PAINTSTRUCT ps;
	HDC hdc;
	HFONT hf, old_hf;
	char tmp[2];
	int len, size;
	DWORD te;
	RECT rc;
	hdc = BeginPaint(hwnd, &ps);
	GetClientRect(hwnd, &rc);
	size = min(rc.bottom, rc.right);
	hf = MakeFont(mb->app->set.font, size, size, 0);
	old_hf = SelectObject(hdc, hf);
	codetostr(mb->code, tmp);
	len = strlen(tmp);
	te = GetTextExtent(hdc, tmp, len);
	CharOut(hdc, (rc.right - LOWORD(te)) / 2, 0, mb->code);
	SelectObject(hdc, old_hf);
	te = GetTextExtent(hdc, mb->str, len = lstrlen(mb->str));
	TextOut(hdc, (rc.right - LOWORD(te)) / 2, size, mb->str, len);
	DeleteObject(hf);
	EndPaint(hwnd, &ps);
}

MSGBOX *initmsgbox(HWND hwnd){
	MSGBOX *mb;
	TEXTMETRIC tm;
	DWORD te;
	RECT rc;
	char *str;
	if((mb = malloc(sizeof(*mb))) == NULL)
		return NULL;
	str = "";
	{
		HDC hdc = GetDC(hwnd);
		te = GetTextExtent(hdc, str, strlen(str));
		GetTextMetrics(hdc, &tm);
		ReleaseDC(hwnd, hdc);
	}
	GetClientRect(hwnd, &rc);
	CreateWindow("button", str, WS_VISIBLE | WS_CHILD,
				0, rc.bottom - (tm.tmHeight + 8),
				rc.right, tm.tmHeight + 8,
				hwnd, (HMENU)IDOK, WtoI(hwnd), NULL);
	return mb;
}

LRESULT CALLBACK _export MsgBoxProc(
		HWND hwnd, UINT msg, WPARAM warg, LPARAM larg){
	MSGBOX *mb;
	switch(msg){
	case WM_CREATE:
		if((mb = initmsgbox(hwnd)) == NULL){
			nomemproc(hwnd);
			return -1;
		}
		memcpy(mb, ((LPCREATESTRUCT)larg)->lpCreateParams, sizeof(*mb));
		SetWindowLong(hwnd, 0, (LONG)mb);
		return 0;
	case WM_PAINT:
		paintmb(hwnd, (MSGBOX *)GetWindowLong(hwnd, 0));
		return 0;
	case WM_COMMAND:
		if(warg == IDOK){
        	DestroyWindow(hwnd);
			return 0;
		}
		break;
	case WM_DESTROY:
		mb = (MSGBOX *)GetWindowLong(hwnd, 0);
		mb->app->hmsgbox = NULL;
		cfree(mb);
		return 0;
	}
	return DefWindowProc(hwnd, msg, warg, larg);
}

void getmissreason(CHECK_LIST *chk, char buf[]){
	switch(chk->err_kind){
	case EK_Error:
		sprintf(buf, "뎚̉\܂");
		break;
	case EK_Space:
		sprintf(buf, "󔒂ł");
		break;
	case EK_Other:
		{
			char tmp[3];
			if(chk->data.code & 0xff00){
				tmp[0] = (chk->data.code >> 8) & 0xff;
				tmp[1] = chk->data.code & 0xff;
				tmp[2] = 0;
			}else{
				tmp[0] = chk->data.code;
				tmp[1] = 0;
			}
			sprintf(buf, "u%svɂȂĂ܂", tmp);
		}
		break;
	case EK_Comment:
		lstrcpy(buf, chk->data.comment);
		break;
	default:
		buf[0] = 0;
		return;
	}
}

int fonttap(HWND hwnd, APPDATA *app, POINT *pt){
	int n;
	HFONT old_hf, hf;
	HDC hdc;
	RECT rc;
	MSGBOX mb;
	TEXTMETRIC tm;
	if((n = selfont(&app->set, pt)) < 0)
		return 0;
	{
		HDC hdc = GetDC(hwnd);
		GetTextMetrics(hdc, &tm);
		ReleaseDC(hwnd, hdc);
	}
	rc.left = (GetSystemMetrics(SM_CXSCREEN) -
			GetSystemMetrics(SM_CYSCREEN) / 2) / 2 - 1;
	rc.right = GetSystemMetrics(SM_CYSCREEN) / 2 + 2;
	rc.top = GetSystemMetrics(SM_CYSCREEN) / 4 - 1;
	rc.bottom = GetSystemMetrics(SM_CYSCREEN) / 2 + 2 +
			GetSystemMetrics(SM_CYCAPTION) + tm.tmHeight +
			tm.tmHeight + 8;
	if(app->hmsgbox != NULL){
		RECT tmp;
		GetWindowRect(app->hmsgbox, &tmp);
		rc.left = tmp.left;
		rc.top = tmp.top;
	}
	mb.code = *(app->text + app->page_No * app->set.frame_count + n);
	mb.str[0] = 0;
	mb.app = app;
	if(app->set.chklist != NULL){
		CHECK_LIST *chk;
		chk = app->set.chklist[app->page_No * app->set.frame_count + n];
		if(iserrmoji(chk))
			getmissreason(chk, mb.str);
	}
	if(app->hmsgbox != NULL)
		DestroyWindow(app->hmsgbox);
	if((app->hmsgbox = CreateWindow(
			_msg_box_class, "̉{",
			WS_CAPTION | WS_SYSMENU | WS_BORDER |
			WS_OVERLAPPED | WS_VISIBLE,
			rc.left, rc.top, rc.right, rc.bottom,
			hwnd, NULL, WtoI(hwnd), &mb)) == NULL){
		ErrorMessage(hwnd, "Creating Window Missed");
		return 1;
	}
	return 1;
}

int loadchk(SETTEI *set, const char fn[], unsigned moji_count){
	char chkname[MAXPATH];
	fnmerge(chkname, NULL, set->dbdir, fn, _chk_ext);
	if(set->chklist != NULL){
		freechecklist(set->chklist, moji_count);
		set->chklist = NULL;
	}
	if(!getfilenum(chkname))
		return 0;
	if((set->chklist = createchecklist(moji_count)) == NULL)
		return 1;
	if(loadchecklist(chkname, set->chklist, moji_count)){
		freechecklist(set->chklist, moji_count);
		set->chklist = NULL;
		return 1;
	}
	return 0;
}

void redrawpage(HWND hwnd, APPDATA *app){
	setmenu(hwnd, app);
	switch(app->mode){
	case WriteMoji:
		if(app->page_No < 0){
			ShowScrollBar(hwnd, SB_VERT, FALSE);
			SetWindowText(hwnd, _titletext);
		}else{
			ShowScrollBar(hwnd, SB_VERT, app->page_count > 1);
			putpageno(hwnd, app->page_No, app->page_count);
		}
		break;
	case SelectName:
		SetWindowText(hwnd, _titletext);
		break;
	case PutTitle:
		ShowScrollBar(hwnd, SB_VERT, FALSE);
		SetWindowText(hwnd, _titletext);
		break;
	}
	InvalidateRect(hwnd, NULL, TRUE);
}

int changepage(HWND hwnd, APPDATA *app, int page_no){
	if(app->update){
		if(savepagesp(app->hopdb,
				app->page_No, app->mp, app->set.frame_count)){
			filemiss(hwnd);
			return 1;
		}
		app->update = 0;
	}
	if(page_no < 0)
		return 0;
	if(loadpageex(&app->set, app->hopdb, page_no, &app->mp)){
		filemiss(hwnd);
		return 1;
	}
	SetScrollPos(hwnd, SB_VERT, app->page_No = page_no, FALSE);
	return 0;
}

void vscrlproc(HWND hwnd, APPDATA *app, WPARAM wParam, LPARAM lParam){
	int tmp;
	if((tmp = getscrollpage(hwnd, wParam, lParam)) != app->page_No){
		changepage(hwnd, app, tmp);
		redrawpage(hwnd, app);
	}
}

void stopcmdproc(HWND hwnd, APPDATA *app, int exflag){
	int err;
	if(app->mode == WriteMoji){
		if(app->update){
			if(app->page_No < 0)
				err = saverlbsp(app->hopdb, app->name_bmp) == FALSE;
			else
				err = savepagesp(app->hopdb,
						app->page_No, app->mp, app->set.frame_count);
			if(err && !exflag){
				filemiss(hwnd);
				return;
			}
		}
		app->set.ai.cur_page = app->page_No;
		if(app->renew){
			getnowday(&(app->set.ai.l_day));
			getnowtime(&(app->set.ai.l_time));
			if(GetOPDBFlagSize(app->hopdb) > app->set.deflaglimit)
				arrangemdbsp(app->hopdb);
		}
		saveheadsp(app->hopdb, &app->set.ai);
		ShowScrollBar(hwnd, SB_VERT, FALSE);
		if(app->set.chklist){
			char chkfn[MAXPATH],
					dr[MAXDRIVE], di[MAXDIR], fi[MAXFILE];
			GetOPDBFileName(app->hopdb, chkfn, MAXPATH);
			fnsplit(chkfn, dr, di, fi, NULL);
			fnmerge(chkfn, dr, di, fi, _chk_ext);
			if(savechecklist(chkfn, app->set.chklist, app->moji_count))
				filemiss(hwnd);
			freechecklist(app->set.chklist, app->moji_count);
			app->set.chklist = NULL;
		}
		ReleaseOPDB(app->hopdb);
		freemparray(app->mp, app->set.frame_count);
		free(app->text);
		if(app->hmsgbox != NULL){
			DestroyWindow(app->hmsgbox);
			app->hmsgbox = NULL;
		}
	}else if(app->mode == SelectName){
		cfree(app->rlblist);
		app->rlblist = NULL;
	}
	app->mode = PutTitle;
	redrawpage(hwnd, app);
}

void closeproc(HWND hwnd, APPDATA *app){
	stopcmdproc(hwnd, app, 1);
	DestroyWindow(hwnd);
}

void repaintproc(HWND hwnd, APPDATA *app){
	HDC hdc;
	PAINTSTRUCT ps;
	hdc = BeginPaint(hwnd, &ps);
	switch(app->mode){
	case WriteMoji:
		if(app->page_No < 0){
			putnamebmp(hdc, app->name_bmp, app->tmp_bmp);
		}else{
			putnoisemargin(hwnd, hdc, app);
			paintproc(hdc, app);
		}
		break;
	case SelectName:
		SelectObject(hdc, app->gobj.hpen[BLACK]);
		putrlbtile(hdc, &app->set,
				app->rlblist, app->rlb_count, app->page_No, app->name_bmp);
		break;
	case PutTitle:
		puttitle(hwnd, hdc, &app->gobj);
		break;
	}
	EndPaint(hwnd, &ps);
}

enum{ MC_PrevDir = 0, MC_NextDir };

int finderrmojino(CHECK_LIST **chk, int count, int cur_pos, int dir){
	int i;
	dir = (dir == MC_PrevDir) ? -1: 1;
	for(i = cur_pos + dir; i < count && i >= 0; i += dir)
		if(iserrmoji(chk[i]))
			return i;
	return cur_pos;
}

int allmodifymsg(HWND hwnd){
	int tmp;
	tmp = MessageBox(hwnd, "C镶͂܂\n\r"
			"͂I܂H", "mF", MB_YESNO | MB_ICONQUESTION);
	if(tmp == IDNO)
		return 1;
	MessageBox(hwnd, "͂肪Ƃ܂",
			"Congratulation", MB_OK | MB_ICONINFORMATION);
	PostMessage(hwnd, WM_COMMAND, WC_Stop, 0);
	return 1;
}

void srchmodifyproc(HWND hwnd, APPDATA *app, int dir){
	int pos, tmp, flag;
	if(app->set.chklist == NULL)
		return;
	pos = app->page_No * app->set.frame_count;
	flag = 0;
	for(;;){
		tmp = finderrmojino(
				app->set.chklist, app->moji_count, pos, dir);
		if(tmp == pos){
			if(!flag){
				pos = (dir == MC_NextDir) ? 0: app->moji_count - 1;
				flag = 1;
				continue;
			}else{
				allmodifymsg(hwnd);
				return;
			}
		}
		pos = tmp;
		if(pos / app->set.frame_count != app->page_No)
			break;
	}
	changepage(hwnd, app, pos / app->set.frame_count);
	redrawpage(hwnd, app);
}

void nextmodifyproc(HWND hwnd, APPDATA *app){
	srchmodifyproc(hwnd, app, MC_NextDir);
}

void prevmodifyproc(HWND hwnd, APPDATA *app){
	srchmodifyproc(hwnd, app, MC_PrevDir);
}

void prevcmdproc(HWND hwnd, APPDATA *app){
	int pos;
	if(app->mode == WriteMoji && app->page_No >= 0){
		if(changepage(hwnd, app, pos = app->page_No - 1))
			return;
		if(pos < 0){
			app->page_No = -1;
			ShowScrollBar(hwnd, SB_VERT, FALSE);
		}
	}else if(app->mode == SelectName){
		if(app->page_No > 0)
			app->page_No--;
	}
	redrawpage(hwnd, app);
}

void nextcmdproc(HWND hwnd, APPDATA *app){
	int pos, tmp;
	if(app->mode == WriteMoji && app->page_No < 0){
		if(app->update){
			if(saverlbsp(app->hopdb, app->name_bmp) == FALSE){
				filemiss(hwnd);
				return;
			}
			app->update = FALSE;
		}
		if(app->page_count > 1)
			ShowScrollBar(hwnd, SB_VERT, TRUE);
		SetScrollPos(hwnd, SB_VERT, app->page_No = 0, FALSE);
	}else if(app->mode == WriteMoji){
		pos = app->page_No + 1;
		if(pos >= app->page_count)
			pos = -1;
		if(changepage(hwnd, app, pos))
			return;
		if(pos < 0){
			tmp = MessageBox(hwnd, "͂I܂H",
					"mF", MB_YESNO | MB_ICONQUESTION);
			if(tmp == IDNO)
				return;
			MessageBox(hwnd, "͂肪Ƃ܂",
					"Congratulation", MB_OK | MB_ICONINFORMATION);
			PostMessage(hwnd, WM_COMMAND, WC_Stop, 0);
			return;
		}
	}else if(app->mode == SelectName){
		if(app->page_No < app->page_count - 1)
			app->page_No++;
	}
	redrawpage(hwnd, app);
}

void newcmdproc(HWND hwnd, APPDATA *app){
	if(readmedlg(hwnd, app->set.readme) == IDCANCEL)
		return;
	setcfgai(WtoI(hwnd), &app->set);
	app->set.chklist = NULL;
	app->set.cflag = 1;
	if(selecttext(hwnd, app->set.text_list, app->set.ai.text_file))
		return;
	if((app->text = ldtextex(hwnd, app->set.ai.text_file)) == NULL)
		return;
	app->moji_count = textlen(app->text);
	app->page_count = (app->moji_count - 1) / app->set.frame_count + 1;
	loadrlbfn(app->set.template, app->name_bmp);
	CopyTempBmp(app->name_bmp, app->tmp_bmp);
	initbmp(app->name_bmp);
	if((app->hopdb = createnewfile(&app->set, app->page_count)) == NULL){
		filemiss(hwnd);
		return;
	}
	if((app->mp = makemparray(app->set.frame_count)) == NULL){
		ReleaseOPDB(app->hopdb);
		nomemproc(hwnd);
		return;
	}
	getnowday(&app->set.ai.f_day);
	getnowtime(&app->set.ai.f_time);
	app->page_No = -1;
	app->update = TRUE;
	app->renew = FALSE;
	app->mode = WriteMoji;
	SetScrollRange(hwnd, SB_VERT, 0, app->page_count - 1, FALSE);
	redrawpage(hwnd, app);
}

int cmdproc(HWND hwnd, APPDATA *app, WPARAM cmd){
	switch(cmd){
	case WC_NextModify:
		nextmodifyproc(hwnd, app);
		return 0;
	case WC_PrevModify:
		prevmodifyproc(hwnd, app);
		return 0;
	case WC_Exit:
		stopcmdproc(hwnd, app, 0);
		DestroyWindow(hwnd);
		return 0;
	case WC_Clear:
		if(app->mode == WriteMoji && app->page_No < 0){
			initbmp(app->name_bmp);
		}else if(app->mode == WriteMoji){
			initmparray(app->mp, app->set.frame_count);
			app->renew = TRUE;
		}
		app->update = TRUE;
		redrawpage(hwnd, app);
		return 0;
	case WC_About:
		AboutDialog(hwnd, "aboutdlg");
		return 0;
	case WC_Prev:
		prevcmdproc(hwnd, app);
		return 0;
	case WC_Next:
		nextcmdproc(hwnd, app);
		return 0;
	case WC_New:
		newcmdproc(hwnd, app);
		return 0;
	case WC_Continue:
		if((app->rlblist = getrlblist(&app->set, &app->rlb_count)) == NULL)
			return 0;
		app->page_No = 0;
		app->page_count = (app->rlb_count - 1) /
				(app->set.rlbdiv * app->set.rlbdiv) + 1;
		app->mode = SelectName;
		redrawpage(hwnd, app);
		return 0;
	case WC_Stop:
		stopcmdproc(hwnd, app, 0);
		return 0;
	}
	return 1;
}

void lbdownproc(HWND hwnd, APPDATA *app, LPARAM lParam){
	HDC hdc;
	POINT pt;
	if(app->mode != WriteMoji)
		return;
	pt.x = (SHORT)LOWORD(lParam);
	pt.y = (SHORT)HIWORD(lParam);
	hdc = GetDC(hwnd);
	if(app->page_No < 0){
		SelectObject(hdc, app->gobj.hpen[BLACK]);
		SelectObject(hdc, app->gobj.hbrush[BLACK]);
		drawbmp(hwnd, hdc, app->name_bmp, &pt);
		app->update = TRUE;
	}else if(!fonttap(hwnd, app, &pt)){
		drawscrn(hwnd, hdc, app, &pt);
	}
	ReleaseDC(hwnd, hdc);
}

int lbdblclkproc(HWND hwnd, APPDATA *app, LPARAM lParam){
	int pos, tmp;
	char dbfname[MAXFILE];
	POINT pt;
	if(app->mode != SelectName)
		return 0;
	pt.x = (SHORT)LOWORD(lParam);
	pt.y = (SHORT)HIWORD(lParam);
	if((tmp = getselname(&app->set,
			app->page_No, app->rlb_count, &pt)) < 0)
		return 1;
	fnsplit(app->rlblist[tmp].fname, NULL, NULL, dbfname, NULL);
	setcfgai(WtoI(hwnd), &app->set);
	app->set.ai.cur_page = -1;
	app->set.ai.text_file[0] = 0;
	if((app->hopdb = loadmdbsp(&app->set, dbfname)) == NULL ||
			loadheadsp(app->hopdb, &(app->set.ai))){
		filemiss(hwnd);
		return 1;
	}
	setacparam(&app->set);
	app->set.cflag = 1;
	if(app->set.display_reso.x != app->set.ai.display_reso.x ||
			app->set.input_reso.x != app->set.ai.input_reso.x ||
			app->set.display_reso.y != app->set.ai.display_reso.y ||
			app->set.input_reso.y != app->set.ai.input_reso.y ||
			app->set.ai.sam_rate != app->set.srate)
		app->set.cflag = 0;
	if((app->text = ldtextex(hwnd, app->set.ai.text_file)) == NULL){
		ReleaseOPDB(app->hopdb);
		return 1;
	}
	app->moji_count = textlen(app->text);
	if(loadchk(&app->set, dbfname, app->moji_count)){
		free(app->text);
		ReleaseOPDB(app->hopdb);
		nomemproc(hwnd);
		return 1;
	}
	if(app->set.chklist){
		if(iserrmoji(app->set.chklist[0]))
			pos = 0;
		else
			pos = finderrmojino(app->set.chklist,
					app->moji_count, 0, MC_NextDir) / app->set.frame_count;
	}else
		pos = app->set.ai.cur_page;
	if((tmp = pos) < 0)
		tmp = 0;
	if((app->mp = loadpagesp(&app->set, app->hopdb, tmp)) == NULL){
		free(app->text);
		ReleaseOPDB(app->hopdb);
		if(app->set.chklist != NULL)
			freechecklist(app->set.chklist, app->moji_count);
		filemiss(hwnd);
		return 1;
	}
	loadrlbfn(app->set.ai.tmp_name, app->name_bmp);
	CopyTempBmp(app->name_bmp, app->tmp_bmp);
	loadrlbsp(app->hopdb, app->name_bmp);
	app->page_No = pos;
	app->page_count = min((app->moji_count - 1) /
			app->set.frame_count + 1, GetOPDBPageCount(app->hopdb));
	free(app->rlblist);
	app->renew = app->update = FALSE;
	app->mode = WriteMoji;
	SetScrollRange(hwnd, SB_VERT, 0, app->page_count - 1, FALSE);
	if(app->page_No > 0)
		SetScrollPos(hwnd, SB_VERT, app->page_No, FALSE);
	redrawpage(hwnd, app);
	return 1;
}

void rbdownproc(HWND hwnd, APPDATA *app, LPARAM lParam){
	HDC hdc;
	POINT pt;
	if(app->mode == WriteMoji && app->page_No < 0){
		pt.x = (SHORT)LOWORD(lParam);
		pt.y = (SHORT)HIWORD(lParam);
		hdc = GetDC(hwnd);
		erasedraw(hwnd, hdc, app->name_bmp, app->tmp_bmp, &pt);
		app->update = TRUE;
		ReleaseDC(hwnd, hdc);
	}
}

void closeapp(HWND hwnd, APPDATA *app){
	if(app->tmp_bmp)
		DeleteObject(app->tmp_bmp);
	if(app->name_bmp)
		DeleteObject(app->name_bmp);
	unsetdrawtool(&app->gobj);
	UnsetCFG(&app->set);
	DestroyCursor(app->refer_csr);
	DestroyCursor(app->erase_csr);
	free(app);
	SetWindowLong(hwnd, 0, 0);
}

APPDATA *initapp(HWND hwnd){
	int err = 1;
	APPDATA *app;
	{
		HMENU hmenu;
		hmenu = GetSystemMenu(hwnd, FALSE);
		DeleteMenu(hmenu, SC_SIZE, MF_BYCOMMAND);
	}
	if((app = calloc(sizeof(*app), 1)) == NULL)
		return NULL;
	app->mode = PutTitle;
	setmenu(hwnd, app);
	if(SetCFG(WtoI(hwnd), &app->set)){
		ErrorMessage(hwnd, "ini t@Cǂݍݎs");
		goto err1;
	}
	setdrawtool(&app->set, &app->gobj);
	ShowScrollBar(hwnd, SB_VERT, FALSE);
	if((app->tmp_bmp = CreateBitmap(GetSystemMetrics(SM_CXSCREEN),
			GetSystemMetrics(SM_CYSCREEN), 1, 1, NULL)) == NULL ||
			(app->name_bmp = CreateBitmap(
			RLBSizeX, RLBSizeY, 1, 1, NULL)) == NULL){
		ErrorMessage(hwnd, "rbg}bv̍쐬Ɏs");
		goto err1;
	}
	app->erase_csr = LoadCursor(WtoI(hwnd), "erase_csr");
	app->refer_csr = LoadCursor(WtoI(hwnd), "refer_csr");
	SetWindowLong(hwnd, 0, (DWORD)app);
	err = 0;
err1:
	if(err){
		closeapp(hwnd, app);
		app = NULL;
	}
	return app;
}

LRESULT setcsrproc(HWND hwnd, APPDATA *app, LPARAM larg){
	if(app->mode == WriteMoji &&
			app->page_No >= 0 && LOWORD(larg) == HTCLIENT){
		POINT pt;
		GetCursorPos(&pt);
		ScreenToClient(hwnd, &pt);
		if(selfont(&app->set, &pt) >= 0){
			SetCursor(app->refer_csr);
			return 1;
		}else if(chkclsw(&app->set, &pt) >= 0){
			SetCursor(app->erase_csr);
			return 1;
		}
	}
	return 0;
}

LRESULT CALLBACK _export WndProc(
		HWND hwnd, UINT wMessage, WPARAM wParam, LPARAM lParam){
	APPDATA *app = (APPDATA *)GetWindowLong(hwnd, 0);
	if(wMessage == WM_CREATE)
		return (initapp(hwnd) != NULL) ? 0: -1;
	switch((app != NULL) ? wMessage: WM_CREATE){
	case WM_DESTROY:
		closeapp(hwnd, app);
		PostQuitMessage(0);
		return 0;
	case WM_CLOSE:
	case WM_QUERYENDSESSION:
		closeproc(hwnd, app);
		return 0;
	case WM_VSCROLL:
		vscrlproc(hwnd, app, wParam, lParam);
		return 0;
	case WM_PAINT:
		repaintproc(hwnd, app);
		return 0;
	case WM_COMMAND:
		if(cmdproc(hwnd, app, wParam))
			break;
		return 0;
	case WM_NCLBUTTONDBLCLK:
		if(wParam == HTCAPTION)
			if(!IsIconic(hwnd)){
				CloseWindow(hwnd);
				return 0;
			}
		break;
	case WM_LBUTTONDBLCLK:
		if(lbdblclkproc(hwnd, app, lParam))
			return 0;
	case WM_LBUTTONDOWN:
		lbdownproc(hwnd, app, lParam);
		return 0;
	case WM_RBUTTONDOWN:
	case WM_RBUTTONDBLCLK:
		rbdownproc(hwnd, app, lParam);
		return 0;
	case WM_SETCURSOR:
		if(setcsrproc(hwnd, app, lParam))
			return 0;
		break;
	case WM_NCLBUTTONDOWN:
		if(wParam == HTCAPTION)
			if(!IsIconic(hwnd)){
				SetActiveWindow(hwnd);
				return 0;
			}
		break;
	case WM_INITMENUPOPUP:
		if(HIWORD(lParam)){
			EnableMenuItem((HMENU)wParam, SC_MOVE, MF_BYCOMMAND |
					(IsIconic(hwnd) ? MF_ENABLED: MF_GRAYED));
		}
		return 0;
	}
	return DefWindowProc(hwnd, wMessage, wParam, lParam);
}

int SetWndClass(HINSTANCE hInst, const char class_name[]){
	WNDCLASS wc;
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= sizeof(APPDATA *);
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, "face_icon");
	wc.hCursor			= LoadCursor(hInst, "dot_csr");
	wc.hbrBackground	= GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName		= "main_menu";
	wc.lpszClassName	= class_name;
	if(!RegisterClass(&wc)){
		MessageBox(NULL, "Registing class is missed !",
				"ERROR !", MB_ICONEXCLAMATION | MB_OK);
		return 1;
	}
	return 0;
}

int SetMsgBoxClass(HINSTANCE hInst, const char class_name[]){
	WNDCLASS wc;
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = (WNDPROC)MsgBoxProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = sizeof(APPDATA *);
	wc.hInstance = hInst;
	wc.hIcon = NULL;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = class_name;
	if(!RegisterClass(&wc)){
		MessageBox(NULL, "Registing class is missed !",
				"ERROR !", MB_ICONEXCLAMATION | MB_OK);
		return 1;
	}
	return 0;
}

void UnsetWndClass(HINSTANCE hinst, const char class_name[]){
	WNDCLASS wc;
	GetClassInfo(hinst, class_name, &wc);
	DestroyCursor(wc.hCursor);
}

HINSTANCE loadpenwin(void){
	HINSTANCE hpenwin;
	if(GetSystemMetrics(SM_PENWINDOWS) == NULL)
		return NULL;
#ifdef __WIN32__
	if((hpenwin = LoadLibrary("penwin32.dll")) == NULL)
#else
	if((hpenwin = LoadLibrary("penwin.dll")) < HINSTANCE_ERROR)
#endif
		return NULL;
	(FARPROC)lpCreatePenData = GetProcAddress(hpenwin, "CreatePenData");
	(FARPROC)lpGetPenDataInfo = GetProcAddress(hpenwin, "GetPenDataInfo");
	(FARPROC)lpGetPenHwEventData =
			GetProcAddress(hpenwin, "GetPenHwEventData");
	(FARPROC)lpIsPenEvent = GetProcAddress(hpenwin, "IsPenEvent");
	(FARPROC)lpTPtoDP = GetProcAddress(hpenwin, "TPtoDP");
	(FARPROC)lpDPtoTP = GetProcAddress(hpenwin, "DPtoTP");
	return hpenwin;
}

#pragma argsused

int PASCAL WinMain(HANDLE hInstance,
		HANDLE hPrevInstance, LPSTR lpCmdParam, int iCmdShow){
	MSG msg;
	HWND hwnd;
	hpenwin = loadpenwin();
	if(!hPrevInstance){
		if(SetWndClass(hInstance, _class_name))
			return 0;
		if(SetMsgBoxClass(hInstance, _msg_box_class))
			return 0;
	}else{
		SetActiveWindow(hwnd);
		return 0;
	}
	hwnd = CreateWindow(_class_name, _titletext,
			WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VSCROLL,
			0, 0, GSM(SM_CXSCREEN), GSM(SM_CYSCREEN),
			NULL, NULL, hInstance, NULL);
	if(!hwnd){
		MessageBox(NULL, "Creating window is missed !",
				"ERROR !", MB_ICONEXCLAMATION | MB_OK);
		return 1;
	}
	ShowWindow(hwnd, SW_MAXIMIZE);
	MessageLoop();
	UnsetWndClass(hInstance, _class_name);
	FreeLibrary(hpenwin);
	return msg.wParam;
}
