#ifndef __MDBIO_H__

#define __MDBIO_H__

#include "opdb.h"

enum{
	MCF_Checked = 1, MCF_Illegal = 2
};

enum{
	EK_Error = 0, EK_Space, EK_Other, EK_Comment
};

typedef struct{
	OPDB_XY start;
	OPDB_XY step;
	OPDB_XY count;
	OPDB_XY size;
} FRAME;

typedef struct{
	FRAME frame;
	OPDB_XY in_reso;
	OPDB_XY out_reso;
} OPDB_METRIC;


typedef struct{
	SHORT left;
	SHORT top;
	SHORT right;
	SHORT bottom;
} OPDB_RECT;

typedef struct tagSTROKE_LIST{
	unsigned count;
	OPDB_XY *pt;
	struct tagSTROKE_LIST *next;
} STROKE_LIST;

typedef struct{
	STROKE_LIST *head;
	STROKE_LIST **tail;
} MOJI_PATTERN;

typedef struct{
// `FbNLC
	char flag;
	char err_kind;
	SHORT score;
// 󔒂ł
// uXXvɂȂĂ܂
// 뎚̉\܂
// Rg
	union{
		char *comment;
		WORD code;
	} data;
} CHECK_LIST;

void freechecklist(CHECK_LIST **cl, int count);
CHECK_LIST **createchecklist(int count);
int loadchecklist(const char *fn, CHECK_LIST **cl, int count);
int savechecklist(const char *fn, CHECK_LIST **cl, int count);

WORD *loadtext(const char *fname);
int textlen(WORD *text);

void initmp(MOJI_PATTERN *mp);
void initmparray(MOJI_PATTERN *mp, int frame_count);

MOJI_PATTERN *makemparray(int frame_count);
void freemparray(MOJI_PATTERN *mp, int frame_count);

int GetOPDBStrokePt(
		HPAGEPAT hpp, int stroke_No, OPDB_XY *pt, void *ai, int count);

int addmpstroke(MOJI_PATTERN *mp, OPDB_XY *pbuf, unsigned pt_count);
void getstrokerect(OPDB_RECT *rc, OPDB_XY *pt, unsigned pt_count);
void getframeorgpos(FRAME *frame, int n, OPDB_XY *org);
int getnearframeno(FRAME *frame, OPDB_XY *pt);

MOJI_PATTERN *loadmparray(HOPDB hopdb,
		int page_No, FRAME *frame, OPDB_XY *in_reso, OPDB_XY *disp_reso);
int savemparray(HOPDB hOpdb, int page_No, MOJI_PATTERN *mp, int frame_count);

void convscale(OPDB_XY *src, OPDB_XY *dst, OPDB_XY *pt);

void setframemargin(OPDB_XY *sz);
void getframemargin(OPDB_XY *sz);

#endif
