/*
-----------------------------------------------------------------------------

				IPDB library for online pattern header file

											95/ 5/ 3	programmed by K.A

-----------------------------------------------------------------------------
*/

#ifndef __OPDB_H__

#define __OPDB_H__

#include "btype.h"
#include "ipdbsys.h"
#include "aif.h"

enum{
	OPDB_FileOpenError = 1, OPDB_MemoryAllocError,
	OPDB_IllegalHeader, OPDB_WriteError, OPDB_ReadError, OPDB_IllegalHandle,
	OPDB_IllegalValue, OPDB_SeekError, OPDB_IllegalFile, OPDB_HandleOver,
	OPDB_IllegalName, OPDB_AlreadyExist, OPDB_NoMatchMemory
};

typedef unsigned HOPDB;
typedef unsigned HPAGEPAT;

typedef struct{
	SHORT x, y;
	void *add_info;
} OPDB_POINT;

typedef struct{
	SHORT x, y;
} OPDB_XY;

#ifdef __cplusplus
extern "C" {
#endif

/* OPDB ɑ΂ IPDB ̃nh𓾂 */
HIPDB GetOPDBsIPDB(HOPDB hopdb);
/* OPDB VK쐬 */
HOPDB CreateOPDB(const char file_name[], HAIFMT set_haif, HAIFMT page_haif,
		HAIFMT stroke_haif, HAIFMT point_haif, unsigned page_count);
/* OPDB ǂݍ */
HOPDB LoadOPDB(const char file_name[]);
/* OPDB  */
void ReleaseOPDB(HOPDB hopdb);

/* OPDB ̃t@C𓾂 */
int GetOPDBFileName(HOPDB hopdb, char fn_buf[], int buf_size);
/* OPDB ̕ttH[}bg̃Rs[𓾂 */
HAIFMT GetOPDBAddInfoFormat(HOPDB hopdb, int kind);

/* y[W𓾂 */
unsigned GetOPDBPageCount(HOPDB hopdb);
/* y[W𑝂₷ */
int AddOPDBPages(HOPDB hopdb, unsigned page_pos, unsigned page_count);
/* y[W炷 */
int DeleteOPDBPages(HOPDB hopdb, unsigned page_pos, unsigned page_count);
/* OPDB ̕t𓾂 */
int LoadOPDBAddInfo(HOPDB hopdb, int offset, void *data, int size);
/* OPDB ̕tݒ肷 */
int SaveOPDBAddInfo(HOPDB hopdb, int offset, void *data, int size);
/* OPDB ̖gp̈̃TCY𓾂 */
long GetOPDBFlagSize(HOPDB hopdb);
/* OPDB ̖gp̈폜 */
int ArrangeOPDB(HOPDB hopdb);

/* ̃y[Wp^[쐬 */
HPAGEPAT CreateOPDBPagePattern(HOPDB hopdb, unsigned page);
/* y[Wp^[ǂݍ */
HPAGEPAT LoadOPDBPagePattern(HOPDB hopdb, unsigned page);
/* y[Wp^[ */
int SaveOPDBPagePattern(HPAGEPAT hpp);
/* y[Wp^[ */
void ReleaseOPDBPagePattern(HPAGEPAT hpp);
/* y[Wp^[ɑ΂ OPDB ̃nh𓾂 */
HOPDB GetPagePatternOPDB(HPAGEPAT hpp);
/* y[Wp^[̃y[Wԍ𓾂 */
unsigned GetOPDBPageNo(HPAGEPAT hpp);
/* y[Wt𓾂 */
int GetOPDBPageAddInfo(HPAGEPAT hpp, int offset, void *data, int size);
/* y[Wtݒ肷 */
int SetOPDBPageAddInfo(HPAGEPAT hpp, int offset, void *data, int size);

/* Xg[N̐𓾂 */
unsigned GetOPDBStrokeCount(HPAGEPAT hpp);
/* Xg[N𓾂 */
int GetOPDBStroke(HPAGEPAT hpp,
		unsigned stroke_No, OPDB_POINT *pt_buf, unsigned buf_count);
/* |Cgz𓾂 */
int GetOPDBPoints(HPAGEPAT hpp, unsigned stroke_No,
		unsigned pt_No, OPDB_POINT *pt_buf, unsigned pt_count);
/* Xg[N𓾂 */
int GetOPDBStrokeXY(HPAGEPAT hpp,
		unsigned stroke_No, OPDB_XY *xy, void *add_info, unsigned buf_count);
/* |Cgz𓾂 */
int GetOPDBPointsXY(HPAGEPAT hpp, unsigned stroke_No,
		unsigned point_No, OPDB_XY *xy, void *add_info, unsigned pt_count);
/* Xg[Nݒ肷 */
int SetOPDBStroke(HPAGEPAT hpp,
		unsigned stroke_No, OPDB_POINT *mp, unsigned point_count);
/* Xg[Nݒ肷 */
int SetOPDBStrokeXY(HPAGEPAT hpp,
		unsigned stroke_No, OPDB_XY *xy, void *add_info, unsigned point_count);
/* Xg[N폜 */
int DeleteOPDBStroke(HPAGEPAT hpp, unsigned stroke_No);
/* Xg[Nǉ */
int AddOPDBStroke(HPAGEPAT hpp,
		unsigned stroke_No, OPDB_POINT *mp, unsigned point_count);
/* Xg[Nǉ */
int AddOPDBStrokeXY(HPAGEPAT hpp,
		unsigned stroke_No, OPDB_XY *xy, void *add_info, unsigned point_count);
/* Xg[Nt𓾂 */
int GetOPDBStrokeAddInfo(HPAGEPAT hpp,
		unsigned stroke_No, int offset, void *data, int size);
/* Xg[Ntݒ肷 */
int SetOPDBStrokeAddInfo(HPAGEPAT hpp,
		unsigned stroke_No, int offset, void *data, int size);
/* Xg[Ñ|Cg𓾂 */
unsigned GetOPDBPointCount(HPAGEPAT hpp, unsigned stroke_No);

/* |Cg^z擾 */
OPDB_POINT *AllocOPDBPoints(HOPDB hopdb, unsigned point_count);
/* |Cg^zp */
void FreeOPDBPoints(OPDB_POINT *mp);

/* G[R[h𓾂 */
int GetOPDBError(void);

#ifdef	__cplusplus
}
#endif

#endif
