/*
=============================================================================

						Windows Tool Library

												Copyright Katsuhiko Akiyama

=============================================================================
					҂̋ȂɎgp邱Ƃւ
=============================================================================
*/

#include "wintool.h"
#include <commdlg.h>
#include <stdio.h>
//#include <alloc.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <dir.h>

#include "bctovc.h"

#define HUGE_

/*
static void repaintprocessbar(HWND hwnd){
	HBRUSH oldbr, hbr;
	HDC hdc;
	PAINTSTRUCT ps;
	RECT rc;
	WORD lv;
	lv = GetWindowWord(hwnd, 0);
	GetClientRect(hwnd, &rc);
	hdc = BeginPaint(hwnd, &ps);
	hbr = CreateSolidBrush(RGB(0, 0, 255));
	oldbr = SelectObject(hdc, hbr);
	Rectangle(hdc, 0, 0,
			(int)((long)rc.right * lv / 100), rc.bottom);
	SelectObject(hdc, oldbr);
	DeleteObject(hbr);
	SetBkMode(hdc, TRANSPARENT);
	SetTextColor(hdc, RGB(255, 255, 0));
	SetROP2(hdc, R2_XORPEN);
	EndPaint(hwnd, &ps);
}

static LRESULT CALLBACK _export ProcessBarProc(
		HWND hwnd, UINT msg, WPARAM warg, LPARAM larg){
	switch(msg){
	case WM_PAINT:
		repaintprocessbar(hwnd);
		return 0;
	case WM_USER:
		return 0;
	}
	return DefWindowProc(hwnd, msg, warg, larg);
}

int SetProcessBarClass(HINSTANCE hinst){
	WNDCLASS wc;
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = (WNDPROC)ProcessBarProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = sizeof(WORD);
	wc.hInstance = hinst;
	wc.hIcon = NULL;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = "processbar";
	return !RegisterClass(&wc);
}

HWND ProcessBarBox(HINSTANCE hinst, HWND hwnd, LPCSTR title){
	HWND hbox;
	SetProcessBarClass(hinst);
//	hbox = CreateWindow(
}*/

char *makevastr(LPCSTR *format){
	int len;
	FILE *fp;
	char *buf;
	va_list argl;

	fp = fopen("nul", "w");
	va_start(argl, *format);
	len = vfprintf(fp, *format, argl);
	va_end(argl);
	fflush(fp);
	fclose(fp);
	if((buf = malloc(len + 1)) == NULL)
		return NULL;
	va_start(argl, *format);
	vsprintf(buf, *format, argl);
	va_end(argl);
	return buf;
}

int TextBox(HWND hwnd, LPCSTR title, UINT flags, LPCSTR format, ...){
	int ret;
	char *str;
	if((str = makevastr(&format)) == NULL)
		return 0;
	ret = MessageBox(hwnd, str, title, flags);
	free(str);
	return ret;
}

void MoveCenter(HWND hwnd){
	RECT rc;
	POINT sz;
	HWND parent;
	GetWindowRect(hwnd, &rc);
	sz.x = rc.right - rc.left;
	sz.y = rc.bottom - rc.top;
	if((parent = GetParent(hwnd)) == NULL)
		parent = GetDesktopWindow();
	GetWindowRect(parent, &rc);
	SetWindowPos(hwnd, NULL,
			(rc.left + rc.right - sz.x) >> 1,
			(rc.top + rc.bottom - sz.y) >> 1, 0, 0,
			SWP_NOZORDER | SWP_NOACTIVATE | SWP_NOSIZE);
}

void PutText(HDC hdc, int x, int y, LPCSTR format, ...){
	char *buf;
	if((buf = makevastr(&format)) == NULL)
		return;
	TextOut(hdc, x, y, buf, lstrlen(buf));
	free(buf);
}

void SetClientSize(HWND hwnd, int sx, int sy){
	RECT rc, rc2;
	GetWindowRect(hwnd, &rc);
	GetClientRect(hwnd, &rc2);
	SetWindowPos(hwnd, NULL, 0, 0,
			(rc.right - rc.left) - (rc2.right - rc2.left) + sx,
			(rc.bottom - rc.top) - (rc2.bottom - rc2.top) + sy,
			SWP_NOZORDER | SWP_NOMOVE | SWP_NOACTIVATE);
}

void GetClientSize(HWND hwnd, POINT *sz){
	RECT rc;
	GetClientRect(hwnd, &rc);
	sz->x = rc.right;
	sz->y = rc.bottom;
}

void ErrorMessage(HWND hwnd, LPCSTR message){
	MessageBox(hwnd, message, "error !", MB_OK | MB_ICONEXCLAMATION);
}

void WaitCursor(void){
	SetCursor(LoadCursor(NULL, IDC_WAIT));
}

//#pragma argsused

static BOOL CALLBACK _export AboutDlgProc(HWND hdlg,
		UINT wMsg, WPARAM wParam, LPARAM lParam){
	switch(wMsg){
	case WM_INITDIALOG:
		return TRUE;
	case WM_COMMAND:
		if(wParam != IDOK)
			break;
	case WM_CLOSE:
		EndDialog(hdlg, 0);
		return TRUE;
	}
	return 0;
}

HINSTANCE WtoI(HWND hwnd){
#ifndef __WIN32__
	return (HINSTANCE)GetWindowWord(hwnd, GWW_HINSTANCE);
#else
	return (HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE);
#endif
}

int OpenDialogEx(HINSTANCE hinst,
		LPCSTR res_name, HWND parent, DLGPROC proc, LPARAM param){
	int ret;
	DLGPROC lpfnDlgProc;
	if(hinst == NULL)
		hinst = WtoI(parent);
#ifndef __WIN32__
	(FARPROC)lpfnDlgProc = MakeProcInstance(proc, hinst);
#else
	lpfnDlgProc = proc;
#endif
	ret = DialogBoxParam(hinst, res_name, parent, lpfnDlgProc, param);
#ifndef __WIN32__
	FreeProcInstance(lpfnDlgProc);
#endif
	return ret;
}

int OpenDialog(HWND parent, LPCSTR res_name, DLGPROC proc, LPARAM param){
	return OpenDialogEx(NULL, res_name, parent, proc, param);
}

int MakeDialog(HINSTANCE hinst, HWND hwnd, DLGPROC proc, LPARAM lp){
	struct{
#ifndef __WIN32__
		struct{
			DWORD style;
			BYTE cdit;
			WORD x;
			WORD y;
			WORD cx;
			WORD cy;
		} dt;
#else
		DLGTEMPLATE dt;
#endif
		WORD name[3];
	} *dlg;
	DLGPROC fnp;
	int ret;
	HGLOBAL hg;
	if((hg = GlobalAlloc(0, sizeof(*dlg))) == NULL)
		return 0;
	(LPVOID)dlg = GlobalLock(hg);
	memset(dlg, 0, sizeof(*dlg));
	dlg->dt.style =
			WS_VISIBLE | WS_BORDER | WS_CAPTION | WS_POPUP | WS_SYSMENU;
	GlobalUnlock(hg);
	if(hinst == NULL)
		hinst = WtoI(hwnd);
#ifndef __WIN32__
	(FARPROC)fnp = MakeProcInstance(proc, hinst);
#else
	fnp = proc;
#endif
	ret = DialogBoxIndirectParam(hinst, hg, hwnd, fnp, lp);
#ifndef __WIN32__
	FreeProcInstance(fnp);
#endif
	GlobalFree(hg);
	return ret;
}

//========================================================================
enum{ GTD_EditID = 100, GTD_EditX = 10, GTD_EditY = 16 };

static int initgettextdlg(HWND hwnd, LPARAM lp){
	struct{
		LPSTR buf;
		int buf_size;
		LPCSTR title;
	} *gtd;
	TEXTMETRIC tm;
	int wsx, wsy, esx, esy, bsx, bsy;
	{
		HDC hdc;
		hdc = GetDC(hwnd);
		GetTextMetrics(hdc, &tm);
		ReleaseDC(hwnd, hdc);
	}
	(LPVOID)gtd = (LPVOID)lp;
	SetWindowText(hwnd, gtd->title);
	SetWindowLong(hwnd, DWL_USER, (LONG)gtd->buf);
	esx = tm.tmMaxCharWidth * gtd->buf_size;
	esy = tm.tmHeight + 2;
	bsx = tm.tmMaxCharWidth * 6;
	bsy = tm.tmHeight + 4;
	wsx = GTD_EditX * 2 + max(esx, bsx * 2 + 2);
	wsy = GTD_EditY + esy + 5 + bsy + 5;
	SetWindowPos(hwnd, NULL, 0, 0,
			wsx + (GSM(SM_CXBORDER) + GSM(SM_CXDLGFRAME)) * 2,
			wsy + GSM(SM_CYCAPTION) + (GSM(SM_CYBORDER) +
			GSM(SM_CYDLGFRAME)) * 2,
			SWP_NOACTIVATE | SWP_NOZORDER | SWP_NOMOVE | SWP_NOREDRAW);
	CreateWindow("edit", gtd->buf,
			WS_VISIBLE | WS_BORDER | WS_CHILD,
			(wsx - esx) / 2, GTD_EditY, esx, esy,
			hwnd, (HMENU)GTD_EditID, WtoI(hwnd), NULL);
	CreateWindow("button", "",
			WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON,
			wsx - bsx * 2 - GTD_EditX - 2, GTD_EditY + esy + 5, bsx, bsy,
			hwnd, (HMENU)IDOK, WtoI(hwnd), NULL);
	CreateWindow("button", "",
			WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON,
			wsx - bsx - GTD_EditX, GTD_EditY + esy + 5, bsx, bsy,
			hwnd, (HMENU)IDCANCEL, WtoI(hwnd), NULL);
	return 0;
}

static BOOL CALLBACK _export gettextdlgproc(
		HWND hwnd, UINT msg, WPARAM wp, LPARAM lp){
	switch(msg){
	case WM_INITDIALOG:
		initgettextdlg(hwnd, lp);
		return 1;
	case WM_CLOSE:
		wp = IDCANCEL;
	case WM_COMMAND:
		if(wp == IDOK || wp == IDCANCEL){
			if(wp == IDOK){
				int n;
				{
					TEXTMETRIC tm;
					HDC hdc;
					RECT rc;
					hdc = GetDC(hwnd);
					GetTextMetrics(hdc, &tm);
					ReleaseDC(hwnd, hdc);
					GetWindowRect(GetDlgItem(hwnd, GTD_EditID), &rc);
					n = (rc.right - rc.left) / tm.tmMaxCharWidth;
				}
				GetWindowText(GetDlgItem(hwnd, GTD_EditID),
						(char *)GetWindowLong(hwnd, DWL_USER), n);
			}
			EndDialog(hwnd, wp);
		}
		return 1;
	}
	return 0;
}

int GetTextDialog(HWND hwnd, LPCSTR title, LPSTR buf, int buf_size){
	struct{
		LPSTR buf;
		int buf_size;
		LPCSTR title;
	} gtd;
	gtd.buf = buf;
	gtd.buf_size = buf_size;
	gtd.title = title;
	return MakeDialog(
			WtoI(hwnd), hwnd, (DLGPROC)gettextdlgproc, (LPARAM)&gtd);
}

//========================================================================
int AboutDialogEx(HINSTANCE hinst, LPCSTR res_name, HWND parent){
	return (OpenDialogEx(hinst, res_name, parent, AboutDlgProc, 0) < 0);
}

int AboutDialog(HWND parent, LPCSTR res_name){
	return AboutDialogEx(NULL, res_name, parent);
}

WPARAM MessageLoop(void){
	MSG msg;
	while(GetMessage(&msg, NULL, 0, 0)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

void SetLogFont(LOGFONT *lf, LPCSTR name, int xsize, int ysize, int flag){
	memset(lf, 0, sizeof(*lf));
	lf->lfWidth = xsize / 2;
	lf->lfHeight = ysize;
	lf->lfEscapement = 0;
	lf->lfOrientation = 0;
	lf->lfWeight = (flag & BoldFont) ? FW_BOLD: FW_NORMAL;
	lf->lfItalic = ((flag & ItalicFont) != 0);
	lf->lfUnderline = ((flag & Underline) != 0);
	lf->lfStrikeOut = 0;
//	lf->lfCharSet = SHIFTJIS_CHARSET;
	lf->lfCharSet = DEFAULT_CHARSET;
	lf->lfOutPrecision = OUT_DEFAULT_PRECIS;
	lf->lfClipPrecision = CLIP_DEFAULT_PRECIS;
	lf->lfQuality = DEFAULT_QUALITY;
	lf->lfPitchAndFamily = FF_DONTCARE | DEFAULT_PITCH;
	lstrcpy(lf->lfFaceName, name);
}

void GetLogFont(LOGFONT *lf, LPSTR name, LPINT xsize, LPINT ysize, LPINT flag){
	if(name != NULL)
		lstrcpy(name, lf->lfFaceName);
	if(xsize != NULL)
		*xsize = (lf->lfWidth < 0) ? -lf->lfHeight: lf->lfWidth;
	if(ysize != NULL)
		*ysize = (lf->lfHeight < 0) ? -lf->lfHeight: lf->lfHeight;
	if(flag != NULL){
		*flag = lf->lfItalic ? ItalicFont: 0;
		if(lf->lfUnderline)
			*flag |= Underline;
		if(lf->lfWeight != FW_NORMAL)
			*flag |= BoldFont;
	}
}

HFONT MakeFont(LPCSTR name, int xsize, int ysize, int flag){
	LOGFONT lf;
	SetLogFont(&lf, name, xsize, ysize, flag);
	return CreateFontIndirect(&lf);
}

int SelectFont(HWND hwnd, LPSTR name, LPINT xsize, LPINT ysize, LPINT flag){
	int err;
	LOGFONT lf;
	CHOOSEFONT cf;
	SetLogFont(&lf,
			name, xsize ? *xsize: 0, ysize ? *ysize: 0, flag ? *flag: 0);
	memset(&cf, 0, sizeof(cf));
	cf.lStructSize = sizeof(CHOOSEFONT);
	cf.hwndOwner = hwnd;
	cf.rgbColors = 0;
	cf.Flags = CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS;
	cf.nFontType = SCREEN_FONTTYPE;
	cf.lpLogFont = &lf;
	err = !ChooseFont(&cf);
	GetLogFont(&lf, name, xsize, ysize, flag);
	return err;
}

static int GetFileNameExEx(HWND hwnd,
		LPCSTR title, LPCSTR mask, LPSTR fn, int bufsize, int mulflag){
	int ret;
	OPENFILENAME ofn;
	char inidir[MAXDIR];
	char *filter = NULL;
	static const char allmsg[] = "ׂĂ̧ (*.*)", allmask[] = "*.*";
	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hwnd;
	ofn.lpstrTitle = title;
	ofn.nMaxFile = bufsize;
	{
		int l;
		char dr[MAXDRIVE], di[max(MAXDIR, MAXFILE + MAXEXT - 1)];
		fnsplit(fn, dr, di, NULL, NULL);
		fnmerge(inidir, dr, di, NULL, NULL);
		fnsplit(fn, NULL, NULL, di, &di[MAXFILE]);
		fnmerge(fn, NULL, NULL, di, &di[MAXFILE]);
		l = lstrlen(inidir);
		if(l >= 1 && inidir[l - 1] == '\\' && (l < 2 || inidir[l - 2] != ':'))
			inidir[l - 1] = 0;
	}
	ofn.lpstrFile= fn;
	ofn.lpstrInitialDir = inidir;
	ofn.nFilterIndex = 0;
	ofn.Flags = OFN_PATHMUSTEXIST |
			OFN_NOCHANGEDIR | (mulflag ? OFN_ALLOWMULTISELECT: 0);
#ifdef __WIN32__
	ofn.Flags |= OFN_NOLONGNAMES;
	if(LOWORD(GetVersion()) >= 4)
		ofn.Flags |= OFN_EXPLORER;
#endif
	if(mask){
		int len;
		char *cur;
		len = lstrlen(mask);
		if((cur = filter = calloc(sizeof(*filter), (len + 1) * 2 +
				sizeof(allmsg) + sizeof(allmask) + 2)) == NULL)
			return 0;
		lstrcpy(cur, mask);
		cur += len + 1;
		lstrcpy(cur, mask);
		cur += len + 1;
		lstrcpy(cur, allmsg);
		cur += sizeof(allmsg);
		lstrcpy(cur, allmask);
		ofn.lpstrFilter = filter;
	}
	if(!GetOpenFileName(&ofn))
		ret = IDCANCEL;
	else
		ret = IDOK;
	cfree(filter);
	return ret;
}

void FreeFileNameList(char **fl){
	char **cur;
	if(fl != NULL){
		for(cur = fl; *cur != NULL; cur++){
			free(*cur);
		}
		free(fl);
	}
}

static int strlensp(LPCSTR str){
	int n = 0;
	int dqflag = 0;
	while(*str && (dqflag || *str != ' ')){
		if(*str == '"')
			dqflag ^= 1;
		str++;
		n++;
	}
	return n;
}

static void strcpysp(LPSTR buf, LPCSTR str){
	while(*str && *str != ' '){
		*buf++ = *str++;
	}
	*buf = 0;
}

char **GetFileNameList(HWND hwnd, LPCSTR title, LPCSTR mask, LPCSTR inifn){
	char **fl = NULL;
	char *fn, *cur;
	int n, nn;
	int use_exp;
	enum{ BufSize = 32768 };
	use_exp = (LOWORD(GetVersion()) >= 4);
	if((fn = malloc(sizeof(char) * BufSize)) == NULL)
		return NULL;
	fn[0] = 0;
	if(inifn != NULL)
		strcpy(fn, inifn);
	if(GetFileNameExEx(hwnd, title, mask, fn, BufSize, 1) != IDOK)
		goto err1;
	cur = fn;
	nn = 1;
	for(;;){
		n = strlensp(cur);
		if(!n)
			break;
		nn++;
		cur += n;
		if(!cur[0] && (!use_exp || !cur[1]))
			break;
		cur++;
	}
	if(nn == 2){
		char *dr, *di, *fnm, *ext;
		dr = fn + MAXPATH * 2;
		di = dr + MAXDRIVE;
		fnm = di + MAXDIR;
		ext = fnm + MAXFILE;
		nn++;
		fnsplit(fn, dr, di, fnm, ext);
		fnmerge(fn, dr, di, NULL, NULL);
		cur = fn + strlen(fn);
		cur[0] = ' ';
		fnmerge(cur + 1, NULL, NULL, fnm, ext);
		if(use_exp)
			cur[strlen(cur) + 1] = 0;
	}
	if((fl = calloc(sizeof(*fl), nn)) == NULL)
		goto err1;
	cur = fn;
	nn = 0;
	for(;;){
		n = strlensp(cur);
		if(!n)
			break;
		if((fl[nn] = malloc(sizeof(char) * (n + 1))) == NULL){
			FreeFileNameList(fl);
			fl = NULL;
			goto err1;
		}
		strcpysp(fl[nn], cur);
		nn++;
		cur += n;
		if(!cur[0] && (!use_exp || !cur[1]))
			break;
		cur++;
	}
err1:
	free(fn);
	return fl;
}

int GetFileNameEx(
		HWND hwnd, LPCSTR title, LPCSTR mask, LPSTR fn, int bufsize){
	return GetFileNameExEx(hwnd, title, mask, fn, bufsize, 0);
}

void GetFileName(HWND hwnd, LPCSTR title, LPSTR fn, int bufsize){
	char ext[MAXEXT + 2];
	{
		char ex[MAXEXT];
		fnsplit(fn, NULL, NULL, NULL, ex);
		lstrcpy(ext, "*");
		lstrcat(ext, ex);
	}
	if(GetFileNameEx(hwnd, title, ext, fn, bufsize) != IDOK)
		fn[0] = 0;
}

void BoxLine(HDC hdc, int x1, int y1, int x2, int y2){
	MoveToEx(hdc, x1, y1, NULL);
	LineTo(hdc, x2, y1);
	LineTo(hdc, x2, y2);
	LineTo(hdc, x1, y2);
	LineTo(hdc, x1, y1);
}

void Pset(HDC hdc, int x, int y){
	MoveToEx(hdc, x, y, NULL);
	LineTo(hdc, x + 1, y);
	MoveToEx(hdc, x, y, NULL);
}

void PutBitmap(HDC hdc, int x, int y,
		HBITMAP hbmp, int xx, int yy, int sx, int sy, DWORD rop){
	HDC hmem;
	HBITMAP oldbm;
	hmem = CreateCompatibleDC(hdc);
	oldbm = SelectObject(hmem, hbmp);
	BitBlt(hdc, x, y, sx, sy, hmem, xx, yy, rop);
	SelectObject(hmem, oldbm);
	DeleteDC(hmem);
}

void CopyBitmap(HBITMAP dst, int x, int y,
		HBITMAP src, int xx, int yy, int sx, int sy, DWORD rop){
	HDC hmem;
	HBITMAP oldbm;
	hmem = CreateCompatibleDC(NULL);
	oldbm = SelectObject(hmem, dst);
	if(dst == src)
		BitBlt(hmem, x, y, sx, sy, hmem, xx, yy, rop);
	else
		PutBitmap(hmem, x, y, src, xx, yy, sx, sy, rop);
	SelectObject(hmem, oldbm);
	DeleteDC(hmem);
}

#ifndef __WIN32__
#define HUGE_		HUGE
#else
#define HUGE_
#endif

static int readf(HFILE hf, void HUGE_ *buf, UINT size){
	return (int)(_hread(hf, buf, size) < (long)size);
}

static int readbfh(HFILE hf){
	BITMAPFILEHEADER bfh;
	if(readf(hf, &bfh, sizeof(bfh)))
		return 1;
	if((bfh.bfType & 0xff) != 'B' || ((bfh.bfType >> 8) & 0xff) != 'M')
		return 1;
	return 0;
}

static BITMAPINFO *readbi(HFILE hf){
	int ctsize;
	BITMAPINFOHEADER bih;
	BITMAPINFO *bi;
	if(readf(hf, &bih, sizeof(bih)))
		return NULL;
	if(!bih.biClrUsed)
		ctsize = (bih.biBitCount < 24) ? 1 << bih.biBitCount: 0;
	else
		ctsize = bih.biClrUsed;
	if((bi = malloc(sizeof(bih) + ctsize * sizeof(RGBQUAD))) == NULL)
		return NULL;
	bi->bmiHeader = bih;
	if(readf(hf, bi->bmiColors, sizeof(RGBQUAD) * ctsize)){
		free(bi);
		return NULL;
	}
	return bi;
}

static void HUGE_ *fmalloc(size_t sz){
#ifdef __WIN32__
	return malloc(sz);
#else
	return farmalloc(sz);
#endif
}

static void ffree(void HUGE_ *p){
#ifdef __WIN32__
	free(p);
#else
	farfree(p);
#endif
}

static void HUGE_ *readbm(HFILE hf, BITMAPINFO *bi){
	void HUGE_ *data, HUGE_ *cur;
	DWORD bmsize, rest, size;
	if((bmsize = bi->bmiHeader.biSizeImage) == 0)
		bmsize = (((bi->bmiHeader.biWidth *
				bi->bmiHeader.biBitCount + 7) / 8 + 3) &
				~3) * bi->bmiHeader.biHeight;
	if((data = fmalloc(bmsize)) == NULL)
		return NULL;
	rest = bmsize;
	cur = data;
	while(rest > 0){
		size = (rest >= 0x7fff) ? 0x7fff: rest;
		if(readf(hf, cur, size)){
			ffree(data);
			return NULL;
		}
		(char HUGE_ *)cur += size;
		rest -= size;
	}
	return data;
}

/*
static int readbmp256(HFILE hf, BITMAPINFO *bi, BYTE HUGE_ *pixels){
	int lsize;
	BYTE *buf;
	int i, j, sx, sy;
	int lsz;
	int err = !0;
	RGBQUAD *tbl = bi->bmiColors, *p;
	struct{
		BYTE r, g, b;
	} HUGE_ *cur;
	sx = bi->bmiHeader.biWidth;
	lsize = sx + 3 & ~3;
	lsz = sx * 3 + 3 & ~3;
	sy = bi->bmiHeader.biHeight;
	if((buf = malloc(lsize)) == NULL)
		return !0;
	for(i = 0; i < sy; i++){
		if(readf(hf, buf, lsize))
			goto err1;
		(BYTE HUGE_ *)cur = pixels + (sy - i - 1) * lsz;
		for(j = 0; j < sx; j++){
			p = &tbl[buf[j]];
			cur->b = p->rgbRed;
			cur->g = p->rgbGreen;
			cur->r = p->rgbBlue;
			cur++;
		}
	}
	err = 0;
err1:
	free(buf);
	return err;
}

static int readbmp16(HFILE hf, BITMAPINFO *bi, BYTE HUGE_ *pixels){
	int lsize;
	BYTE *buf;
	int i, j, sx, sy;
	int lsz;
	int err = !0;
	RGBQUAD *tbl = bi->bmiColors, *p;
	struct{
		BYTE r, g, b;
	} HUGE_ *cur;
	sx = bi->bmiHeader.biWidth;
	lsize = (sx * 4 + 7) / 8 + 3 & ~3;
	lsz = sx * 3 + 3 & ~3;
	sy = bi->bmiHeader.biHeight;
	if((buf = malloc(lsize)) == NULL)
		return !0;
	for(i = sy - 1; i >= 0; i--){
		if(readf(hf, buf, lsize))
			goto err1;
		(BYTE HUGE_ *)cur = pixels + i * lsz;
		for(j = 0; j < sx; j++){
			p = &tbl[(buf[j >> 1] >> ((~j & 1) << 2)) & 0xf];
			cur->r = p->rgbRed;
			cur->g = p->rgbGreen;
			cur->b = p->rgbBlue;
			cur++;
		}
	}
	err = 0;
err1:
	free(buf);
	return err;
}

static int readbmp2(HFILE hf, BITMAPINFO *bi, BYTE HUGE_ *pixels){
	int lsize;
	BYTE *buf;
	int i, j, sx, sy;
	int lsz;
	int err = !0;
	RGBQUAD *tbl = bi->bmiColors, *p;
	struct{
		BYTE r, g, b;
	} HUGE_ *cur;
	sx = bi->bmiHeader.biWidth;
	lsize = (sx + 7) / 8 + 3 & ~3;
	lsz = sx * 3 + 3 & ~3;
	sy = bi->bmiHeader.biHeight;
	if((buf = malloc(lsize)) == NULL)
		return !0;
	for(i = sy - 1; i >= 0; i--){
		if(readf(hf, buf, lsize))
			goto err1;
		(BYTE HUGE_ *)cur = pixels + i * lsz;
		for(j = 0; j < sx; j++){
			p = &tbl[(buf[j >> 3] >> (7 - (j & 7))) & 1];
			cur->r = p->rgbRed;
			cur->g = p->rgbGreen;
			cur->b = p->rgbBlue;
			cur++;
		}
	}
	err = 0;
err1:
	free(buf);
	return err;
}

static int readbmp16m(HFILE hf, BITMAPINFO *bi, BYTE HUGE_ *pixels){
	int lsize = bi->bmiHeader.biWidth * 3 + 3 & ~3;
	int i;
	int sy;
	int err = !0;
	sy = bi->bmiHeader.biHeight;
	for(i = sy - 1; i >= 0; i--){
		if(readf(hf, pixels + i * lsize, lsize))
			goto err1;
	}
	err = 0;
err1:
	return err;
}

static int readbm2(HFILE hf, BITMAPINFO *bi, void *data){
	int err = !0;
	switch(bi->bmiHeader.biBitCount){
	case 1:
		err = readbmp2(hf, bi, data);
		break;
	case 4:
		err = readbmp16(hf, bi, data);
		break;
	case 8:
		err = readbmp256(hf, bi, data);
		break;
	case 24:
		err = readbmp16m(hf, bi, data);
		break;
	}
err1:
	return err;
}*/

static void setusedcolortable(
		BITMAPINFOHEADER *bih, VOID HUGE_ *data, int ct[], int csize){
	int i, j, k, l;
	BYTE d;
	BYTE HUGE_ *cur;
	k = (((bih->biWidth * bih->biBitCount + 7) / 8 + 3) & ~3) -
			(bih->biWidth * bih->biBitCount + 7) / 8;
	csize--;
	cur = data;
	for(j = 0; j < bih->biHeight; j++){
		i = 0;
		while(i < bih->biWidth){
			d = *cur++;
			for(l = bih->biBitCount; l <= 8; l += bih->biBitCount){
				ct[(d >> (8 - l)) & csize] = 1;
				if(++i >= bih->biWidth)
					break;
			}
		}
		cur += k;
	}
}

static HPALETTE makehpal(
		BITMAPINFOHEADER *bih, VOID HUGE_ *data, RGBQUAD *rq, int ctsize){
	int i, j;
	LOGPALETTE *lp;
	PALETTEENTRY *pal;
	HPALETTE hpal = NULL;
	int *ct = NULL;
	int csize;
	if(data != NULL){
		csize = 1 << bih->biBitCount;
		if((ct = calloc(sizeof(*ct), csize)) == NULL)
			return NULL;
		setusedcolortable(bih, data, ct, csize);
	}
	if((lp = malloc(sizeof(*lp) + sizeof(*pal) * ctsize)) == NULL)
		goto err1;
	lp->palVersion = 0x300;
	pal = lp->palPalEntry;
	j = 0;
	for(i = 0; i < ctsize; i++, rq++){
		if(ct != NULL && !ct[i])
			continue;
		pal->peRed = rq->rgbRed;
		pal->peGreen = rq->rgbGreen;
		pal->peBlue = rq->rgbBlue;
		pal->peFlags = (BYTE)NULL;
		pal++;
		j++;
	}
	lp->palNumEntries = j;
	hpal = CreatePalette(lp);
	cfree(lp);
err1:
	free(ct);
	return hpal;
}

HPALETTE MakeDefPalette(void){
	int b, r, g;
	LOGPALETTE *lp;
	PALETTEENTRY *pal;
	HPALETTE hpal;
	int n;
	enum{ ColorReso = 6 };
	if((lp = malloc(sizeof(*lp) + sizeof(PALETTEENTRY) *
			(ColorReso * ColorReso * ColorReso))) == NULL)
		return NULL;
	lp->palVersion = 0x300;
	pal = lp->palPalEntry;
	n = 0;
	for(g = 0; g < ColorReso; g++){
		for(r = 0; r < ColorReso; r++){
			for(b = 0; b < ColorReso; b++){
				pal->peRed = 0xff * r / (ColorReso - 1);
				pal->peGreen = 0xff * g / (ColorReso - 1);
				pal->peBlue = 0xff * b / (ColorReso - 1);
				pal->peFlags = 0;
//				if(pal->peRed + pal->peGreen + pal->peBlue == 0)
//					continue;
				n++;
				pal++;
			}
		}
	}
	lp->palNumEntries = n;
	hpal = CreatePalette(lp);
	cfree(lp);
	return hpal;
}

typedef struct tagCOLOR_LIST{
	RGBTRIPLE color;
	char dummy;
	struct tagCOLOR_LIST *next;
} COLOR_LIST;

enum{
	BrtReso = 10, CLTableSize = BrtReso * BrtReso * BrtReso
};

static COLOR_LIST **makecoltbl(void){
	return calloc(sizeof(COLOR_LIST *), CLTableSize);
}

static void freecollist(COLOR_LIST *clist){
	COLOR_LIST *next;
	while(clist != NULL){
		next = clist->next;
		free(clist);
		clist = next;
	}
}

static void freecoltbl(COLOR_LIST **coltbl){
	int i;
	COLOR_LIST **cur = coltbl;
	for(i = 0; i < CLTableSize; i++)
		freecollist(*cur++);
	free(coltbl);
}

static COLOR_LIST *searchcollist(COLOR_LIST *cl, RGBTRIPLE *rgb){
	while(cl != NULL){
		if(cl->color.rgbtRed == rgb->rgbtRed &&
				cl->color.rgbtGreen == rgb->rgbtGreen &&
				cl->color.rgbtBlue == rgb->rgbtBlue)
			return cl;
		cl = cl->next;
	}
	return NULL;
}

static int addcoltbl(COLOR_LIST **coltbl, RGBTRIPLE *rgb){
	int n;
	COLOR_LIST *tmp;
	n = (rgb->rgbtGreen * ((BrtReso - 1) * 2) / 0xff + 1) >> 1;
	n = n * BrtReso + ((rgb->rgbtRed * ((BrtReso - 1) * 2) / 0xff + 1) >> 1);
	n = n * BrtReso + ((rgb->rgbtBlue * ((BrtReso - 1) * 2) / 0xff + 1) >> 1);
	coltbl += n;
	if(searchcollist(*coltbl, rgb) != NULL)
		return 0;
	if((tmp = malloc(sizeof(*tmp))) == NULL)
		return 1;
	tmp->color.rgbtRed = rgb->rgbtRed;
	tmp->color.rgbtGreen = rgb->rgbtGreen;
	tmp->color.rgbtBlue = rgb->rgbtBlue;
	tmp->next = *coltbl;
	*coltbl = tmp;
	return 0;
}

static int colordist(RGBTRIPLE *c1, RGBTRIPLE *c2){
	int d1, d2, d3;
	d1 = abs(c1->rgbtBlue - c2->rgbtBlue);
	d2 = abs(c1->rgbtRed - c2->rgbtRed);
	d3 = abs(c1->rgbtGreen - c2->rgbtGreen);
	return max(max(d1, d2), d3);
}

static long getcllen(COLOR_LIST *cl){
	long n = 0;
	while(cl != NULL){
		n++;
		cl = cl->next;
	}
	return n;
}

static long getcolcnt(COLOR_LIST **ct){
	int i;
	long n = 0;
	for(i = 0; i < CLTableSize; i++)
		n += getcllen(*ct++);
	return n;
}

static COLOR_LIST **gettypicalcol(COLOR_LIST **ct, int idx, int farflag){
	RGBTRIPLE c;
	COLOR_LIST **cur, *tmp, **ret = NULL;
	int d, md;
	cur = &ct[idx];
	c.rgbtBlue = 0xff * (idx % BrtReso) / (BrtReso - 1);
	idx /= BrtReso;
	c.rgbtRed = 0xff * (idx % BrtReso) / (BrtReso - 1);
	idx /= BrtReso;
	c.rgbtGreen = 0xff * (idx % BrtReso) / (BrtReso - 1);
	if(farflag){
		md = -0x7fff;
		while((tmp = *cur) != NULL){
			if((d = colordist(&tmp->color, &c)) > md){
				md = d;
				ret = cur;
			}
			cur = &tmp->next;
		}
	}else{
		md = 0x7fff;
		while((tmp = *cur) != NULL){
			if((d = colordist(&tmp->color, &c)) < md){
				md = d;
				ret = cur;
			}
			cur = &tmp->next;
		}
	}
	return ret;
}

static COLOR_LIST **bmptocoltbl(BITMAPINFOHEADER *bih, void HUGE_ *data){
	RGBTRIPLE HUGE_ *rgb;
	COLOR_LIST **coltbl;
	int i, j, k, err = 1;
	if((coltbl = makecoltbl()) == NULL)
		return NULL;
	rgb = data;
	k = (4 - (bih->biWidth * sizeof(*rgb) & 3)) & 3;
	for(j = 0; j < bih->biHeight; j++){
		for(i = 0; i < bih->biWidth; i++){
			if(addcoltbl(coltbl, (RGBTRIPLE *)(rgb++)))
				goto err1;
		}
		(char HUGE_ *)rgb += k;
	}
	err = 0;
err1:
	if(err){
		freecoltbl(coltbl);
		coltbl = NULL;
	}
	return coltbl;
}

static LOGPALETTE *coltbltolp(COLOR_LIST **coltbl){
	int i, j, k;
	COLOR_LIST **cur_tbl;
	COLOR_LIST *tmp;
	int palnum;
	long n;
	HDC hdc;
	LOGPALETTE *lp = NULL;
	PALETTEENTRY *pal;
	hdc = GetDC(NULL);
	palnum = GetDeviceCaps(hdc,
			SIZEPALETTE) - GetDeviceCaps(hdc, NUMRESERVED);
	ReleaseDC(NULL, hdc);
	n = getcolcnt(coltbl);
	palnum = min(palnum, n);
	if((lp = malloc(sizeof(*lp) + sizeof(PALETTEENTRY) * palnum)) == NULL)
		return NULL;
	lp->palVersion = 0x300;
	lp->palNumEntries = palnum;
	pal = lp->palPalEntry;
	j = 0;
	k = 0;
	while(j < palnum){
		for(i = 0; i < CLTableSize; i++){
			if((cur_tbl = gettypicalcol(coltbl, i, k & 1)) == NULL)
				continue;
			tmp = *cur_tbl;
/*			if(!tmp->color.rgbtRed &&
					!tmp->color.rgbtGreen && !tmp->color.rgbtBlue){
				palnum--;
				continue;
			}*/
			*cur_tbl = tmp->next;
			pal->peRed = tmp->color.rgbtRed;
			pal->peGreen = tmp->color.rgbtGreen;
			pal->peBlue = tmp->color.rgbtBlue;
			pal->peFlags = 0;
			pal++;
			j++;
			free(tmp);
			if(j >= palnum)
				break;
		}
		k++;
	}
	return lp;
}

static HPALETTE coltbltohpal(COLOR_LIST **coltbl){
	LOGPALETTE *lp;
	HPALETTE hpal = NULL;
	if((lp = coltbltolp(coltbl)) != NULL){
		hpal = CreatePalette(lp);
		free(lp);
	}
	return hpal;
}

static HPALETTE makeoptpal(BITMAPINFOHEADER *bih, void HUGE_ *data){
	COLOR_LIST **coltbl;
	HPALETTE hpal;
	if((coltbl = bmptocoltbl(bih, data)) == NULL)
		return NULL;
	hpal = coltbltohpal(coltbl);
	freecoltbl(coltbl);
	return hpal;
}

static int setcoltblfromhpal(COLOR_LIST **coltbl, HPALETTE hpal){
	HDC hdc;
	int palnum;
	PALETTEENTRY *cur, *pe;
	RGBTRIPLE rgb;
	int i, err = 1;
	hdc = GetDC(NULL);
	palnum = GetDeviceCaps(hdc,
			SIZEPALETTE) - GetDeviceCaps(hdc, NUMRESERVED);
	ReleaseDC(NULL, hdc);
	if((cur = pe = malloc(sizeof(*pe) * palnum)) == NULL)
		return 1;
	palnum = GetPaletteEntries(hpal, 0, palnum, pe);
	for(i = 0; i < palnum; i++, cur++){
		rgb.rgbtRed = cur->peRed;
		rgb.rgbtGreen = cur->peGreen;
		rgb.rgbtBlue = cur->peBlue;
		if(addcoltbl(coltbl, &rgb))
			goto err1;
	}
	err = 0;
err1:
	cfree(pe);
	return err;
}

int ConbinePalette(HPALETTE base, HPALETTE add){
	COLOR_LIST **coltbl;
	LOGPALETTE *lp;
	int err = 1;
	if((coltbl = makecoltbl()) == NULL)
		return 0;
	if(setcoltblfromhpal(coltbl, base))
		goto err1;
	if(setcoltblfromhpal(coltbl, add))
		goto err1;
	if((lp = coltbltolp(coltbl)) != NULL){
		if(lp->palNumEntries){
			ResizePalette(base, lp->palNumEntries);
			err = !SetPaletteEntries(
					base, 0, lp->palNumEntries, lp->palPalEntry);
		}
		free(lp);
	}
err1:
	freecoltbl(coltbl);
	return err;
}

HPALETTE GetBMPFilePalette(LPCSTR fname){
	HPALETTE hpal = NULL;
	int ctsize;
	HFILE hf;
	void HUGE_ *data = NULL;
	BITMAPINFO *bi = NULL;
#ifndef __WIN32__
	if((hf = _lopen(fname, READ)) == HFILE_ERROR)
#else
	if((hf = _lopen(fname, OF_READ)) == HFILE_ERROR)
#endif
		return NULL;
	if(readbfh(hf))
		goto err1;
	if((bi = readbi(hf)) == NULL)
		goto err1;
	if(!bi->bmiHeader.biClrUsed)
		ctsize = (bi->bmiHeader.biBitCount < 24) ?
				1 << bi->bmiHeader.biBitCount: 0;
	else
		ctsize = bi->bmiHeader.biClrUsed;
	if(bi->bmiHeader.biCompression != BI_RLE8 &&
			bi->bmiHeader.biCompression != BI_RLE4){
		if((data = readbm(hf, bi)) == NULL)
			goto err1;
	}
	hpal = ctsize ? makehpal(&bi->bmiHeader, data,
			bi->bmiColors, ctsize): makeoptpal(&bi->bmiHeader, data);
err1:
	if(data)
		ffree(data);
	cfree(bi);
	_lclose(hf);
	return hpal;
}

int IsPaletteUsable(void){
	HDC hdc;
	int flag;
	hdc = GetDC(NULL);
	flag = GetDeviceCaps(hdc, RASTERCAPS) & RC_PALETTE;
	ReleaseDC(NULL, hdc);
	return flag;
}

/*
HBITMAP LoadDIBSection(LPCSTR fname, BYTE **pbmp){
	HFILE hf;
	HBITMAP hbm = NULL;
	BITMAPINFO *bi = NULL;
	void HUGE_ *data = NULL;
	HDC hdc;
	int err = !0;
#ifndef __WIN32__
	if((hf = _lopen(fname, READ)) == HFILE_ERROR)
#else
	if((hf = _lopen(fname, OF_READ)) == HFILE_ERROR)
#endif
		return NULL;
	if(readbfh(hf))
		goto err1;
	if((bi = readbi(hf)) == NULL)
		goto err1;
	hdc = GetDC(NULL);
	{
		BITMAPINFO bmi;
		bmi.bmiHeader = bi->bmiHeader;
		bmi.bmiHeader.biHeight = -bmi.bmiHeader.biHeight;
		bmi.bmiHeader.biPlanes = 1;
		bmi.bmiHeader.biBitCount = 24;
		bmi.bmiHeader.biCompression = BI_RGB;
		bmi.bmiHeader.biClrUsed = 0;
		bmi.bmiHeader.biClrImportant = 0;
		hbm = CreateDIBSection(
				hdc, &bmi, DIB_RGB_COLORS, (void **)pbmp, NULL, 0);
	}
	ReleaseDC(NULL, hdc);
	if(hbm == NULL)
		goto err1;
	if(readbm2(hf, bi, *pbmp))
		goto err1;
	err = 0;
err1:
	if(err){
		if(hbm){
			DeleteObject(hbm);
			hbm = NULL;
		}
	}
	cfree(bi);
	_lclose(hf);
	return hbm;
}*/

HBITMAP LoadBMPFile(LPCSTR fname, HPALETTE hpal){
	HFILE hf;
	HBITMAP hbm = NULL;
	BITMAPINFO *bi = NULL;
	void HUGE_ *data = NULL;
	HDC hdc;
#ifndef __WIN32__
	if((hf = _lopen(fname, READ)) == HFILE_ERROR)
#else
	if((hf = _lopen(fname, OF_READ)) == HFILE_ERROR)
#endif
		return NULL;
	if(readbfh(hf))
		goto err1;
	if((bi = readbi(hf)) == NULL)
		goto err1;
	if((data = readbm(hf, bi)) == NULL)
		goto err1;
	hdc = GetDC(NULL);
	if((GetDeviceCaps(hdc, RASTERCAPS) & RC_PALETTE) && hpal != NULL){
		SelectPalette(hdc, hpal, 0);
		RealizePalette(hdc);
	}
	hbm = CreateDIBitmap(
			hdc, &bi->bmiHeader, CBM_INIT, data, bi, DIB_RGB_COLORS);
	ReleaseDC(NULL, hdc);
err1:
	if(data)
		ffree(data);
	cfree(bi);
	_lclose(hf);
	return hbm;
}

void cfree(void *p){
	if(p != NULL)
		free(p);
}
