#ifndef __WINTOOL_H__

#define __WINTOOL_H__

#include <windows.h>
#include <string.h>

#define GSM(x)			GetSystemMetrics(x)
#define AC(x)			(sizeof(x) / sizeof(*(x)))
#define ZC(x)			(memset(&(x), 0, sizeof(x)))

#define VK_ROLLDOWN		0x21
#define VK_ROLLUP		0x22
#define VK_COMMA		0xbc
#define VK_PERIOD		0xbe
#define VK_SEMICOLON	0xbb
#define VK_COLON		0xba
#define VK_SLASH		0xbf
#define VK_UNDERBAR		0xdf

enum{ BoldFont = 1, ItalicFont = 2, Underline = 4 };

#ifdef __cplusplus
extern "C" {
#endif

char *makevastr(LPCSTR *format);
int TextBox(HWND hwnd, LPCSTR title, UINT flags, LPCSTR format, ...);
void ErrorMessage(HWND hwnd, LPCSTR message);
int OpenDialog(HWND parent, LPCSTR res_name, DLGPROC proc, LPARAM param);
int OpenDialogEx(HINSTANCE hinst,
		LPCSTR res_name, HWND parent, DLGPROC proc, LPARAM param);
int MakeDialog(HINSTANCE hinst, HWND hparent, DLGPROC proc, LPARAM lp);
int GetTextDialog(HWND hwnd, LPCSTR title, LPSTR buf, int buf_size);
int AboutDialog(HWND parent, LPCSTR res_name);
int AboutDialogEx(HINSTANCE hinst, LPCSTR res_name, HWND parent);
void MoveCenter(HWND hwnd);

void SetClientSize(HWND hwnd, int sx, int sy);
void GetClientSize(HWND hwnd, POINT *size);
WPARAM MessageLoop(void);
HINSTANCE WtoI(HWND hwnd);
void WaitCursor(void);

HFONT MakeFont(LPCSTR name, int xsize, int ysize, int flag);
void SetLogFont(LOGFONT *lf, LPCSTR name, int xsize, int ysize, int flag);
void GetLogFont(LOGFONT *lf, LPSTR name, LPINT xsize, LPINT ysize, LPINT flag);
int SelectFont(HWND hwnd, LPSTR name, LPINT xsize, LPINT ysize, LPINT flag);

void FreeFileNameList(char **fl);
char **GetFileNameList(HWND hwnd, LPCSTR title, LPCSTR mask, LPCSTR inifn);
void GetFileName(HWND hwnd, LPCSTR title, LPSTR fnbuf, int bufsize);
int GetFileNameEx(HWND hwnd,
		LPCSTR title, LPCSTR filter, LPSTR fnbuf, int bufsize);

void Pset(HDC hdc, int x, int y);
void BoxLine(HDC hdc, int x1, int y1, int x2, int y2);
void PutText(HDC hdc, int x, int y, LPCSTR format, ...);
void PutBitmap(HDC hdc, int x, int y,
		HBITMAP hbmp, int xx, int yy, int sx, int sy, DWORD rop);
void CopyBitmap(HBITMAP dst, int x, int y,
		HBITMAP src, int xx, int yy, int sx, int sy, DWORD rop);

HPALETTE MakeDefPalette(void);
int IsPaletteUsable(void);
HPALETTE GetBMPFilePalette(LPCSTR fname);
int ConbinePalette(HPALETTE base, HPALETTE add);
HBITMAP LoadBMPFile(LPCSTR fname, HPALETTE hpal);
//HBITMAP LoadDIBSection(LPCSTR fname, BYTE **pbmp);

void cfree(void *p);

#ifdef __cplusplus
}
#endif

#endif
